<?php
/* $Id: PurchData.php 5237 2012-04-09 11:36:02Z tim_schofield $*/

include ('includes/session.inc');

$title = _('Supplier Purchasing Data');

include ('includes/header.inc');

if (isset($_GET['SupplierID'])) {
	$SupplierID = trim(mb_strtoupper($_GET['SupplierID']));
} elseif (isset($_POST['SupplierID'])) {
	$SupplierID = trim(mb_strtoupper($_POST['SupplierID']));
}

if (isset($_GET['StockID'])) {
	$StockID = trim(mb_strtoupper($_GET['StockID']));
} elseif (isset($_POST['StockID'])) {
	$StockID = trim(mb_strtoupper($_POST['StockID']));
}

if (isset($_POST['StockUOM'])) {
	$StockUOM=$_POST['StockUOM'];
}

$NoPurchasingData=0;

echo '<a href="' . $rootpath . '/SelectProduct.php">' . _('Back to Items') . '</a><br />';

if (isset($_POST['SupplierDescription'])) {
	$_POST['SupplierDescription'] = trim($_POST['SupplierDescription']);
}

if ((isset($_POST['AddRecord']) OR isset($_POST['UpdateRecord'])) AND isset($SupplierID)) { /*Validate Inputs */
	$InputError = 0; /*Start assuming the best */
	if ($StockID == '' OR !isset($StockID)) {
		$InputError = 1;
		prnMsg(_('There is no stock item set up enter the stock code or select a stock item using the search page'), 'error');
	}
	if (!is_numeric(filter_number_format($_POST['Price']))) {
		$InputError = 1;
		unset($_POST['Price']);
		prnMsg(_('The price entered was not numeric and a number is expected. No changes have been made to the database'), 'error');
	}
	if ($_POST['Price'] == 0) {
		prnMsg(_('The price entered is zero') . '   ' . _('Is this intentional?'), 'warn');
	}
	if (!is_numeric(filter_number_format($_POST['LeadTime']))) {
		$InputError = 1;
		unset($_POST['LeadTime']);
		prnMsg(_('The lead time entered was not numeric a number of days is expected no changes have been made to the database'), 'error');
	}
	if (!is_numeric(filter_number_format($_POST['MinOrderQty']))) {
		$InputError = 1;
		unset($_POST['MinOrderQty']);
		prnMsg(_('The minimum order quantity was not numeric and a number is expected no changes have been made to the database'), 'error');
	}
	if (!is_numeric(filter_number_format($_POST['ConversionFactor']))) {
		$InputError = 1;
		unset($_POST['ConversionFactor']);
		prnMsg(_('The conversion factor entered was not numeric') . ' (' . _('a number is expected') . '). ' . _('The conversion factor is the number which the price must be divided by to get the unit price in our unit of measure') . '. <br />' . _('E.g.') . ' ' . _('The supplier sells an item by the tonne and we hold stock by the kg') . '. ' . _('The suppliers price must be divided by 1000 to get to our cost per kg') . '. ' . _('The conversion factor to enter is 1000') . '. <br /><br />' . _('No changes will be made to the database'), 'error');
	}
	if ($InputError == 0 AND isset($_POST['AddRecord'])) {
		$sql = "INSERT INTO purchdata (supplierno,
										stockid,
										price,
										effectivefrom,
										suppliersuom,
										conversionfactor,
										supplierdescription,
										suppliers_partno,
										leadtime,
										minorderqty,
										preferred)
									VALUES ('" . $SupplierID . "',
										'" . $StockID . "',
										'" . filter_number_format($_POST['Price']) . "',
										'" . FormatDateForSQL($_POST['EffectiveFrom']) . "',
										'" . $_POST['SuppliersUOM'] . "',
										'" . $_POST['ConversionFactor'] . "',
										'" . $_POST['SupplierDescription'] . "',
										'" . $_POST['SupplierCode'] . "',
										'" . $_POST['LeadTime'] . "',
										'" . $_POST['MinOrderQty'] . "',
										'" . $_POST['Preferred'] . "'
									)";
		$ErrMsg = _('The supplier purchasing details could not be added to the database because');
		$DbgMsg = _('The SQL that failed was');
		$AddResult = DB_query($sql, $db, $ErrMsg, $DbgMsg);
		prnMsg(_('This supplier purchasing data has been added to the database'), 'success');

		/* If the new purchdata is the preferred one, the old ones from the same suppliers shouldn't be preferred.
		Are kept only for historic information only */
		if ($_POST['Preferred'] == 1){
			$sql = "UPDATE purchdata SET preferred='0'
								WHERE purchdata.stockid='".$StockID."'
									AND purchdata.supplierno='".$SupplierID."'
									AND purchdata.effectivefrom < '" . FormatDateForSQL($_POST['EffectiveFrom']) . "'";
			$ErrMsg = _('The preferred supplier details could not be update because');
			$DbgMsg = _('The SQL that failed was');
			$UpdResult = DB_query($sql, $db, $ErrMsg, $DbgMsg);
			prnMsg(_('Supplier preferred flag has been updated'), 'success');
		}
	}
	if ($InputError == 0 AND isset($_POST['UpdateRecord'])) {
		$sql = "UPDATE purchdata SET price='" . filter_number_format($_POST['Price']) . "',
									effectivefrom='" . FormatDateForSQL($_POST['EffectiveFrom']) . "',
									suppliersuom='" . $_POST['SuppliersUOM'] . "',
									conversionfactor='" . $_POST['ConversionFactor'] . "',
									supplierdescription='" . $_POST['SupplierDescription'] . "',
									suppliers_partno='" . $_POST['SupplierCode'] . "',
									leadtime='" . $_POST['LeadTime'] . "',
									minorderqty='" . $_POST['MinOrderQty'] . "',
									preferred='" . $_POST['Preferred'] . "'
							WHERE purchdata.stockid='".$StockID."'
								AND purchdata.supplierno='".$SupplierID."'
								AND purchdata.effectivefrom='" . $_POST['WasEffectiveFrom'] . "'";
		$ErrMsg = _('The supplier purchasing details could not be update because');
		$DbgMsg = _('The SQL that failed was');
		$UpdResult = DB_query($sql, $db, $ErrMsg, $DbgMsg);
		prnMsg(_('Supplier purchasing data has been updated'), 'success');
	}
	if ($InputError == 0 AND (isset($_POST['UpdateRecord']) OR isset($_POST['AddRecord']))) {
		/*update or insert took place and need to clear the form  */
		unset($SupplierID);
		unset($_POST['Price']);
		unset($CurrCode);
		unset($_POST['SuppliersUOM']);
		unset($_POST['EffectiveFrom']);
		unset($_POST['ConversionFactor']);
		unset($_POST['SupplierDescription']);
		unset($_POST['LeadTime']);
		unset($_POST['Preferred']);
		unset($_POST['SupplierCode']);
		unset($_POST['MinOrderQty']);
		unset($SuppName);
	}
}

if (isset($_GET['Delete'])) {
	$sql = "DELETE FROM purchdata
				WHERE purchdata.supplierno='".$SupplierID."'
				AND purchdata.stockid='".$StockID."'
				AND purchdata.effectivefrom='" . $_GET['EffectiveFrom'] . "'";
	$ErrMsg = _('The supplier purchasing details could not be deleted because');
	$DelResult = DB_query($sql, $db, $ErrMsg);
	prnMsg(_('This purchasing data record has been successfully deleted'), 'success');
	unset($SupplierID);
}

if (!isset($_GET['Edit'])) {
	echo '<p class="page_title_text"><img src="' . $rootpath . '/css/' . $theme . '/images/maintenance.png" title="' . _('Search') . '" alt="" />' . ' ' . $title . ' ' . _('For Stock Code') . ' - ' . $StockID . '</p><br />';
	$sql = "SELECT purchdata.supplierno,
					suppliers.suppname,
					purchdata.price,
					suppliers.currcode,
					purchdata.effectivefrom,
					purchdata.suppliersuom,
					purchdata.supplierdescription,
					purchdata.leadtime,
					purchdata.suppliers_partno,
					purchdata.minorderqty,
					purchdata.preferred,
					purchdata.conversionfactor,
					currencies.decimalplaces AS currdecimalplaces
				FROM purchdata
				INNER JOIN suppliers
					ON purchdata.supplierno=suppliers.supplierid
				INNER JOIN currencies
					ON suppliers.currcode=currencies.currabrev
				WHERE purchdata.stockid = '" . $StockID . "'
				ORDER BY purchdata.effectivefrom DESC, supplierno";
	$ErrMsg = _('The supplier purchasing details for the selected part could not be retrieved because');
	$PurchDataResult = DB_query($sql, $db, $ErrMsg);
	if (DB_num_rows($PurchDataResult) == 0 and $StockID != '') {
		prnMsg(_('There is no purchasing data set up for the part selected'), 'info');
		$sql="SELECT stockmaster.decimalplaces
				FROM stockmaster
				WHERE stockmaster.stockid = '" . $StockID . "'";
		$DecimalPlacesResult=DB_query($sql, $db);
		$DecimalPlacesRow=DB_fetch_array($DecimalPlacesResult);
		$StockDecimalPlaces=$DecimalPlacesRow['decimalplaces'];
		$NoPurchasingData=1;
	} else if ($StockID != '') {
		echo '<table cellpadding="2" class="selection">';
		$TableHeader = '<tr>
							<th>' . _('Supplier') . '</th>
							<th>' . _('Price') . '</th>
							<th>' . _('Currency') . '</th>
							<th>' . _('Effective From') . '</th>
							<th>' . _('Supplier Unit') . '</th>
							<th>' . _('Conversion Factor') . '</th>
							<th>' . _('Price Our Units') . '</th>
							<th>' . _('Min Order Qty') . '</th>
							<th>' . _('Lead Time') . '</th>
							<th>' . _('Preferred') . '</th>
						</tr>';
		echo $TableHeader;
		$CountPreferreds = 0;
		$k = 0; //row colour counter
		while ($myrow = DB_fetch_array($PurchDataResult)) {
			if ($myrow['preferred'] == 1) {
				echo '<tr class="EvenTableRows">';
			} elseif ($k == 1) {
				echo '<tr class="EvenTableRows">';
				$k = 0;
			} else {
				echo '<tr class="OddTableRows">';
				$k++;
			}
			if ($myrow['preferred'] == 1) {
				$DisplayPreferred = _('Yes');
				$CountPreferreds++;
			} else {
				$DisplayPreferred = _('No');
			}
			printf('<td>%s</td>
					<td class="number">%s</td>
					<td>%s</td>
					<td>%s</td>
					<td>%s</td>
					<td class="number">%s</td>
					<td class="number">%s</td>
					<td class="number">%s</td>
					<td class="number">%s ' . _('days') . '</td>
					<td>%s</td>
					<td><a href="%s?StockID=%s&amp;SupplierID=%s&amp;Edit=1&amp;EffectiveFrom=%s">' . _('Edit') . '</a></td>
					<td><a href="%s?StockID=%s&amp;SupplierID=%s&amp;Copy=1&amp;EffectiveFrom=%s">' . _('Copy') . '</a></td>
					<td><a href="%s?StockID=%s&amp;SupplierID=%s&amp;Delete=1&amp;EffectiveFrom=%s" onclick="return confirm(\'' . _('Are you sure you wish to delete this suppliers price?') . '\');">' . _('Delete') . '</a></td>
					</tr>',
					$myrow['suppname'],
					locale_number_format($myrow['price'], $myrow['currdecimalplaces']),
					$myrow['currcode'],
					ConvertSQLDate($myrow['effectivefrom']),
					$myrow['suppliersuom'],
					locale_number_format($myrow['conversionfactor'],'Variable'),
					locale_number_format($myrow['price']/$myrow['conversionfactor'],$myrow['currdecimalplaces']),
					locale_number_format($myrow['minorderqty'],'Variable'),
					locale_number_format($myrow['leadtime'],'Variable'),
					$DisplayPreferred,
					htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES, 'UTF-8'),
					$StockID,
					$myrow['supplierno'],
					$myrow['effectivefrom'],
					htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES, 'UTF-8'),
					$StockID,
					$myrow['supplierno'],
					$myrow['effectivefrom'],
					htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES, 'UTF-8'),
					$StockID,
					$myrow['supplierno'],
					$myrow['effectivefrom']);
		} //end of while loop
		echo '</table><br />';
		if ($CountPreferreds > 1) {
			prnMsg(_('There are now') . ' ' . $CountPreferreds . ' ' . _('preferred suppliers set up for') . ' ' . $StockID . ' ' . _('you should edit the supplier purchasing data to make only one supplier the preferred supplier'), 'warn');
		} elseif ($CountPreferreds == 0) {
			prnMsg(_('There are NO preferred suppliers set up for') . ' ' . $StockID . ' ' . _('you should make one supplier only the preferred supplier'), 'warn');
		}
	} // end of there are purchsing data rows to show
	echo '<br />';
} /* Only show the existing purchasing data records if one is not being edited */

if (isset($SupplierID) AND $SupplierID != '' AND !isset($_POST['SearchSupplier'])) { /*NOT EDITING AN EXISTING BUT SUPPLIER selected OR ENTERED*/
	$sql = "SELECT suppliers.suppname,
					suppliers.currcode,
					currencies.decimalplaces AS currdecimalplaces
				FROM suppliers
				INNER JOIN currencies
					ON suppliers.currcode=currencies.currabrev
				WHERE supplierid='".$SupplierID."'";
	$ErrMsg = _('The supplier details for the selected supplier could not be retrieved because');
	$DbgMsg = _('The SQL that failed was');
	$SuppSelResult = DB_query($sql, $db, $ErrMsg, $DbgMsg);
	if (DB_num_rows($SuppSelResult) == 1) {
		$myrow = DB_fetch_array($SuppSelResult);
		$SuppName = $myrow['suppname'];
		$CurrCode = $myrow['currcode'];
		$CurrDecimalPlaces = $myrow['currdecimalplaces'];
	} else {
		prnMsg(_('The supplier code') . ' ' . $SupplierID . ' ' . _('is not an existing supplier in the database') . '. ' . _('You must enter an alternative supplier code or select a supplier using the search facility below'), 'error');
		unset($SupplierID);
	}
} else {
	if ($NoPurchasingData=0) {
		echo '<p class="page_title_text"><img src="' . $rootpath . '/css/' . $theme . '/images/maintenance.png" title="' . _('Search') . '" alt="" />' . ' ' . $title . ' ' . _('For Stock Code') . ' - ' . $StockID . '</p><br />';
	}
	if (!isset($_POST['SearchSupplier'])) {
		echo '<form action="' . htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES, 'UTF-8') . '" method="post">';
        echo '<div>';
		echo '<input type="hidden" name="FormID" value="' . $_SESSION['FormID'] . '" />';
		echo '<input type="hidden" name="StockID" value="' . $StockID . '" />';
        echo '<table cellpadding="3" class="selection">
                <tr>';
		echo '<td>' . _('Text in the Supplier') . ' <b>' . _('NAME') . '</b>:</td>';
		echo '<td><input type="text" name="Keywords" size="20" maxlength="25" /></td>';
		echo '<td><b>' . _('OR') . '</b></td>';
		echo '<td>' . _('Text in Supplier') . ' <b>' . _('CODE') . '</b>:</td>';
		echo '<td><input type="text" name="SupplierCode" size="10" maxlength="10" /></td>';
		echo '</tr></table><br />';
		echo '<div class="centre">
				<input type="submit" name="SearchSupplier" value="' . _('Find Suppliers Now') . '" />
			</div>
            </div>
			</form>';
		include ('includes/footer.inc');
		exit;
	};
}

if (isset($_GET['Edit'])) {
	echo '<p class="page_title_text"><img src="' . $rootpath . '/css/' . $theme . '/images/maintenance.png" title="' . _('Search') . '" alt="" />' . ' ' . $title . ' ' . _('For Stock Code') . ' - ' . $StockID . '</p><br />';
}

if (isset($_POST['SearchSupplier'])) {
	if (isset($_POST['Keywords']) AND isset($_POST['SupplierCode'])) {
		prnMsg( _('Supplier Name keywords have been used in preference to the Supplier Code extract entered') . '.', 'info' );
		echo '<br />';
	}
	if ($_POST['Keywords'] == '' AND $_POST['SupplierCode'] == '') {
		$_POST['Keywords'] = ' ';
	}
	if (mb_strlen($_POST['Keywords']) > 0) {
		//insert wildcard characters in spaces
		$SearchString = '%' . str_replace(' ', '%', $_POST['Keywords']) . '%';

		$SQL = "SELECT suppliers.supplierid,
						suppliers.suppname,
						suppliers.currcode,
						suppliers.address1,
						suppliers.address2,
						suppliers.address3
					FROM suppliers
					WHERE suppliers.suppname " . LIKE  . " '".$SearchString."'";

	} elseif (mb_strlen($_POST['SupplierCode']) > 0) {
		$SQL = "SELECT suppliers.supplierid,
						suppliers.suppname,
						suppliers.currcode,
						suppliers.address1,
						suppliers.address2,
						suppliers.address3
					FROM suppliers
					WHERE suppliers.supplierid " . LIKE . " '%" . $_POST['SupplierCode'] . "%'";

	} //one of keywords or SupplierCode was more than a zero length string
	$ErrMsg = _('The suppliers matching the criteria entered could not be retrieved because');
	$DbgMsg = _('The SQL to retrieve supplier details that failed was');
	$SuppliersResult = DB_query($SQL, $db, $ErrMsg, $DbgMsg);
} //end of if search

if (isset($StockID)) {
	$result = DB_query("SELECT stockmaster.description,
								stockmaster.units,
								stockmaster.mbflag
						FROM stockmaster
						WHERE stockmaster.stockid='".$StockID."'", $db);
	$myrow = DB_fetch_array($result);
	$StockUOM = $myrow['units'];
	if (DB_num_rows($result) == 1) {
		if ($myrow['mbflag'] == 'D' OR $myrow['mbflag'] == 'A' OR $myrow['mbflag'] == 'K') {
			prnMsg($StockID . ' - ' . $myrow['description'] . '<br /> ' . _('The item selected is a dummy part or an assembly or kit set part') . ' - ' . _('it is not purchased') . '. ' . _('Entry of purchasing information is therefore inappropriate'), 'warn');
			include ('includes/footer.inc');
			exit;
		} else {
 //			echo '<br /><font color="blue" size="3"><b>' . $StockID . ' - ' . $myrow[0] . ' </b>  (' . _('In Units of') . ' ' . $myrow[1] . ' )</font>';
		}
	} else {
		prnMsg(_('Stock Item') . ' - ' . $StockID . ' ' . _('is not defined in the database'), 'warn');
	}
} else {
	$StockID = '';
	$StockUOM = 'each';
}

if (isset($SuppliersResult)) {
	echo '<form action="' . htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES, 'UTF-8') . '" method="post">';
    echo '<div>';
	echo '<input type="hidden" name="FormID" value="' . $_SESSION['FormID'] . '" />';
    echo '<table cellpadding="2" class="selection">';
	$TableHeader = '<tr>
						<th>' . _('Code') . '</th>
						<th>' . _('Supplier Name') . '</th>
						<th>' . _('Currency') . '</th>
						<th>' . _('Address 1') . '</th>
						<th>' . _('Address 2') . '</th>
						<th>' . _('Address 3') . '</th>
					</tr>';
	echo $TableHeader;
	$k = 0;
	while ($myrow = DB_fetch_array($SuppliersResult)) {
		if ($k==1){
			echo '<tr class="EvenTableRows">';
			$k=0;
		} else {
			echo '<tr class="OddTableRows">';
			$k++;
		}
		printf('<td><input type="submit" name="SupplierID" value="%s" /></td>
				<td>%s</td>
				<td>%s</td>
				<td>%s</td>
				<td>%s</td>
				<td>%s',
				$myrow['supplierid'],
				$myrow['suppname'],
				$myrow['currcode'],
				$myrow['address1'],
				$myrow['address2'],
				$myrow['address3']);

		echo '<input type="hidden" name="StockID" value="' . $StockID . '" />';
		echo '<input type="hidden" name="StockUOM" value="' . $StockUOM . '" /></td></tr>';

	}
	//end of while loop
	echo '</table><br/>';
    echo '</div>
          </form>';
}
//end if results to show

/*Show the input form for new supplier purchasing details */
if (!isset($SuppliersResult)) {
	if (isset($_GET['Edit']) or isset($_GET['Copy'])) {
		$sql = "SELECT purchdata.supplierno,
				suppliers.suppname,
				purchdata.price,
				purchdata.effectivefrom,
				suppliers.currcode,
				purchdata.suppliersuom,
				purchdata.supplierdescription,
				purchdata.leadtime,
				purchdata.conversionfactor,
				purchdata.suppliers_partno,
				purchdata.minorderqty,
				purchdata.preferred,
				stockmaster.units,
				currencies.decimalplaces AS currdecimalplaces
		FROM purchdata INNER JOIN suppliers
			ON purchdata.supplierno=suppliers.supplierid
		INNER JOIN stockmaster
			ON purchdata.stockid=stockmaster.stockid
		INNER JOIN currencies
			ON suppliers.currcode = currencies.currabrev
		WHERE purchdata.supplierno='".$SupplierID."'
		AND purchdata.stockid='".$StockID."'
		AND purchdata.effectivefrom='" . $_GET['EffectiveFrom'] . "'";

		$ErrMsg = _('The supplier purchasing details for the selected supplier and item could not be retrieved because');
		$EditResult = DB_query($sql, $db, $ErrMsg);
		$myrow = DB_fetch_array($EditResult);
		$SuppName = $myrow['suppname'];
		if (isset($_GET['Edit'])) {
			$_POST['EffectiveFrom'] = ConvertSQLDate($myrow['effectivefrom']);
			$_POST['Price'] = $myrow['price'];
		} else {
			$_POST['EffectiveFrom'] = Date($_SESSION['DefaultDateFormat']);
			$_POST['Price'] = 0;
		}
		$CurrCode = $myrow['currcode'];
		$CurrDecimalPlaces = $myrow['currdecimalplaces'];
		$_POST['SuppliersUOM'] = $myrow['suppliersuom'];
		$_POST['SupplierDescription'] = $myrow['supplierdescription'];
		$_POST['LeadTime'] = locale_number_format($myrow['leadtime'],'Variable');

		$_POST['ConversionFactor'] = locale_number_format($myrow['conversionfactor'],'Variable');
		$_POST['Preferred'] = $myrow['preferred'];
		$_POST['MinOrderQty'] = locale_number_format($myrow['minorderqty'],'Variable');
		$_POST['SupplierCode'] = $myrow['suppliers_partno'];
		$StockUOM=$myrow['units'];
	}
	echo '<form action="' . htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES, 'UTF-8') . '" method="post">';
    echo '<div>';
	echo '<input type="hidden" name="FormID" value="' . $_SESSION['FormID'] . '" />';
	echo '<table class="selection">
			<tr>
				<th colspan="3"><h3>' . _('Data for Purchasing') . ' ' . $StockID . ' ' . _('from') . ' '. $SupplierID . '</h3></th>
			</tr>';
	if (!isset($SupplierID)) {
		$SupplierID = '';
	}
	if (isset($_GET['Edit'])) {
		echo '<tr><td>' . _('Supplier Name') . ':</td>
		<td><input type="hidden" name="SupplierID" value="' . $SupplierID . '" />' . $SupplierID . ' - ' . $SuppName . '<input type="hidden" name="WasEffectiveFrom" value="' . $myrow['effectivefrom'] . '" /></td>
		</tr>';
	} else {
		echo '<tr>
				<td>' . _('Supplier Name') . ':
		           <input type="hidden" name="SupplierID" maxlength="10" size="11" value="' . $SupplierID . '" />
                </td>';
		if (!isset($SuppName) OR $SuppName == "") {
			echo '<td>(' . _('A search facility is available below if necessary') . ')';
		} else {
			echo '<td>'.$SuppName;
		}
		echo '</td></tr>';
	}
   	echo '<tr><td><input type="hidden" name="StockID" maxlength="10" size="11" value="' . $StockID . '" /></td></tr>';
	if (!isset($CurrCode)) {
		$CurrCode = '';
	}
	if (!isset($_POST['Price'])) {
		$_POST['Price'] = 0;
	}
	if (!isset($_POST['EffectiveFrom'])) {
		$_POST['EffectiveFrom'] = Date($_SESSION['DefaultDateFormat']);
	}
	if (!isset($_POST['SuppliersUOM'])) {
		$_POST['SuppliersUOM'] = '';
	}
	if (!isset($_POST['SupplierDescription'])) {
		$_POST['SupplierDescription'] = '';
	}
   if (!isset($_POST['SupplierCode'])) {
		$_POST['SupplierCode'] = '';
	}
   if (!isset($_POST['MinOrderQty'])) {
		$_POST['MinOrderQty'] = '1';
	}
	echo '<tr><td>' . _('Currency') . ':</td>
	<td><input type="hidden" name="CurrCode" value="' . $CurrCode . '" />' . $CurrCode . '</td></tr>';
	echo '<tr><td>' . _('Price') . ' (' . _('in Supplier Currency') . '):</td>
	<td><input type="text" class="number" name="Price" maxlength="12" size="12" value="' . $_POST['Price'] . '" /></td></tr>';
	echo '<tr><td>' . _('Date Updated') . ':</td>
	<td><input type="text" class="date" alt="' . $_SESSION['DefaultDateFormat'] . '" name="EffectiveFrom" maxlength="10" size="11" value="' . $_POST['EffectiveFrom'] . '" /></td></tr>';
	echo '<tr><td>' . _('Our Unit of Measure') . ':</td>';
	if (isset($SupplierID)) {
		echo '<td>' . $StockUOM . '</td></tr>';
	}
	echo '<tr><td>' . _('Suppliers Unit of Measure') . ':</td>';
	echo '<td><input type="text" name="SuppliersUOM" size="20" maxlength="20" value ="' . $_POST['SuppliersUOM'] . '"/>';
	 echo '</td></tr>';
	if (!isset($_POST['ConversionFactor'])
		OR $_POST['ConversionFactor'] == '') {
		$_POST['ConversionFactor'] = 1;
	}
	echo '<tr><td>' . _('Conversion Factor (to our UOM)') . ':</td>
	<td><input type="text" class="number" name="ConversionFactor" maxlength="12" size="12" value="' . $_POST['ConversionFactor'] . '" /></td></tr>';
	echo '<tr><td>' . _('Supplier Stock Code') . ':</td>
	<td><input type="text" name="SupplierCode" maxlength="50" size="20" value="' . $_POST['SupplierCode'] . '" /></td></tr>';
	echo '<tr><td>' . _('MinOrderQty') . ':</td>
	<td><input type="text" class="number" name="MinOrderQty" maxlength="15" size="15" value="' . $_POST['MinOrderQty'] . '" /></td></tr>';
	echo '<tr><td>' . _('Supplier Stock Description') . ':</td>
	<td><input type="text" name="SupplierDescription" maxlength="50" size="50" value="' . $_POST['SupplierDescription'] . '" /></td></tr>';
	if (!isset($_POST['LeadTime']) OR $_POST['LeadTime'] == "") {
		$_POST['LeadTime'] = 1;
	}
	echo '<tr><td>' . _('Lead Time') . ' (' . _('in days from date of order') . '):</td>
	<td><input type="text" class="number" name="LeadTime" maxlength="4" size="5" value="' . $_POST['LeadTime'] . '" /></td></tr>';
	echo '<tr><td>' . _('Preferred Supplier') . ':</td>
	<td><select name="Preferred">';
	if ($_POST['Preferred'] == 1) {
		echo '<option selected="selected" value="1">' . _('Yes') . '</option>';
		echo '<option value="0">' . _('No') . '</option>';
	} else {
		echo '<option value="1">' . _('Yes') . '</option>';
		echo '<option selected="selected" value="0">' . _('No') . '</option>';
	}
	echo '</select></td></tr></table><br /><div class="centre">';
	if (isset($_GET['Edit'])) {
		echo '<input type="submit" name="UpdateRecord" value="' . _('Update') . '" />';
	} else {
		echo '<input type="submit" name="AddRecord" value="' . _('Add') . '" />';
	}
	echo '</div>';
	echo '<div class="centre">';
	if (isset($StockLocation) and isset($StockID) AND mb_strlen($StockID) != 0) {
		echo '<br /><a href="' . $rootpath . '/StockStatus.php?StockID=' . $StockID . '">' . _('Show Stock Status') . '</a>';
		echo '<br /><a href="' . $rootpath . '/StockMovements.php?StockID=' . $StockID . '&amp;StockLocation=' . $StockLocation . '">' . _('Show Stock Movements') . '</a>';
		echo '<br /><a href="' . $rootpath . '/SelectSalesOrder.php?SelectedStockItem=' . $StockID . '&amp;StockLocation=' . $StockLocation . '">' . _('Search Outstanding Sales Orders') . '</a>';
		echo '<br /><a href="' . $rootpath . '/SelectCompletedOrder.php?SelectedStockItem=' . $StockID . '">' . _('Search Completed Sales Orders') . '</a>';
	}
	echo '</div>';
    echo '</div>
          </form>';
}

include ('includes/footer.inc');
?>