BEGIN;
INSERT INTO `Help` VALUES (3, 130, 'Enter the suppliers name and postal address, terms of payment', '');
INSERT INTO `Help` VALUES (4, 160, 'The main menu is split into sections depending on the user\'s module selection from the tabs accross the top of the menu. The screen actually is different for different users depending on the modules that the system administrator has elected to let you see. Some or all of:\r\n<LI> Orders </LI>\r\n<LI> Receivables </LI>\r\n<LI> Payables </LI>\r\n<LI> Purchasing </LI>\r\n<LI> Inventory </LI>\r\n<LI> Manufacturing </LI>\r\n<LI> Set Up </LI>\r\n<P>Selecting any of these tabs then shows the options available grouped between transactions in the first box, then inquiries or reports in the middle box, then maintenance in the bottom section. Clicking on the text of any option on the main menu proceeds to perform that action.\r\n<P><B>Using the Short Cut Menu</B>\r\n<P>Most actions involving customers will require selection of a customer first, similarly for suppliers and inventory the supplier or item must be selected first. Having selected the customer/supplier/item the selection screens show a sub menu relavent to the selected customer/supplier/item for most transactions and inquiries this is the more direct method of actioning. The traditional menu is available to aid the transition to this method of navigation.\r\n', '');
INSERT INTO `Help` VALUES (5, 93, 'Enter either a portion of the suppliers name or a portion of the suppliers code then hit the search now button.\r\nThe suppliers with the entered text in their name or code will show. Clicking on the button in the code column selects a supplier. Once a supplier has been selected then all the options relevant to the supplier show with links split into three columns - inquiries, transactions, maintenance:\r\n<LI>Supplier Account Inquiry</LI>\r\n<LI>Show this suppliers outstanding purchase orders</LI>\r\n<LI>Show all the suppliers purchase orders</LI>\r\n<LI>Show Shipments set up from the Supplier</LI>\r\n\r\nUnder Transactions Links there are links to enter a suppliers invoice, a debit (credit) note, a payment to the supplier or reverse goods received from a supplier.\r\n\r\nUnder Maintenance Links - the details of the supplier can be amended, new contacts together with email addresses can be maintained and new shipments initiated.\r\n', 'S');
INSERT INTO `Help` VALUES (8, 133, '<font size="+2"><b>Setting Up Users</b></font>\r\n<br /><br />\r\nHaving logged in as the demonstration user. A new user should be defined whom has administrative privileges and the demonstration user should be deleted. From the menu click on the Setup tab and the select Set Up User Accounts, the users defined are displayed and User names must be 5 characters or more and the password entered must be 5 characters or more too. The password cannot also be the user name or contain the user name. It is not necessary to enter the full name telephone and other details. The access level selected is important as this determines the pages that the user can access. In any business where the employees are not also the owners it is advisable to split the functions between staff so that no user can complete an entire transaction. There are occasions in smaller businesses where this is impractical. However, the system has great flexibility to allow the user access to be finely defined. See the security schema section. \r\n<br /><br />\r\nAs well as allowing the access to be restricted there is some flexibility about the links that are made available to a user. In the user account screen the system administrator can define which tabs of the main menu are activiated and available to the user.\r\n<br /><br />\r\nThere is also the facility to set up customers with their own logon. This restricts them to inquiries on their account including invoice re-prints and to entering new sales order. Customer logins do not allow any modification to the pricing. To do this the access level must be set to customer logon and the settings for customer logon in config.php must not be modified - ie $PageSecurity = 1 allowed only. In addition, the customer code and branch code applicable to the person logging on must be entered.\r\n<br /><br />\r\n<font size="+3"><b>Security Schema</b></font>\r\n<br /><br />\r\nThe user name and password combination entered at logon enables the system to identify the permissions appropriate to the user. It is possible to determine and restrict which pages a user should be able to access. Each user is allocated to an Access Level or Security Group. \r\n<br /><br />\r\nThe Security group must be defined in config.php in two ways. \r\n<br /><br />\r\n<ul>\r\n<li>The Security Group Headings are defined in an array called SecurityHeadings.\r\n<li>The Security Group page access codes applicable to the group must be defined in the SecurityGroups array - in the same order as the SecurityHeadings array. Ie the first security heading refers to the first array stored in the SecurityGroups array.\r\n</ul>\r\nEach script is defined as having a specific PageSecurity level. At the time of writing this is a number between 1 and 15 - if more levels of security are necessary then this can be expanded. The current PageSecurity settings applicable for each page are set out in the table below.\r\n<br /><br />\r\nIf the PageSecurity setting of the page is a number contained in the SecurityGroup array as determined from the users access level then the user will be allowed access to the page. The user access level is an integer that represents the index number of the array element of the SecurityGroups array defined in config.php.\r\n<br /><br />\r\nAccess authority is checked in header.inc script for all pages (or PDF_Starter.inc for PDF pages). The variable $_SESSION["AccessLevel"] is retrieved from the database when the user logs in. This variable refers to the index of the SecurityGroups array or arrays. The array of numbers that is referenced by this index defines the pages a user can see. Any page that has a $PageSecurity equal to any value in this array is deemed to be an authorised page.\r\n<br /><br />\r\nIf you wish to add more security groups then you must add a new Security Heading to the $SecurityHeadings array and a new array of PageSecurity numbers to the $SecurityGroups array. This mechanism allows the system administrator to closely and accurately control who can access what.\r\n<br /><br />\r\nBy changing the numbers in each array the security access can be tailored for all users referring to the array being modified. When setting the numbers in the array, reference to the index of PageSecurity values below will be necessary. Of course the value of the default settings can easily be modified.\r\n<br /><br />\r\nThe default settings in config.php are as follows:\r\n<br /><br />\r\nIndex Group\r\n<br /><br />\r\n0 Inquiries Only\r\n<br />\r\n1 Manufacturing/Inventory Admin\r\n<br />\r\n2 Purchasing officer\r\n<br />\r\n3 AP Clerk\r\n<br />\r\n4 AR Clerk\r\n<br />\r\n5 Accountant\r\n<br />\r\n6 Customer logon \r\n<br />\r\n7 System Administrator\r\n<br /><br />\r\nto achieve this the following array for $SecurityHeadings is defined - the index number starting from 0 is incremented for each entry:\r\n<br /><br />\r\n$SecurityHeadings = array(\r\n<br />\r\n"Inquiries/Order Entry",\r\n<br />\r\n"Manufac/Inventory Admin",\r\n<br />\r\n"Purchasing Officer",\r\n<br />\r\n"AP Clerk",\r\n<br />\r\n"AR Clerk",\r\n<br />\r\n"Accountant",\r\n<br />\r\n"Customer Log On Only",\r\n<br />\r\n"System Administrator"\r\n<br />\r\n);\r\n<br /><br />\r\nthe corresponding array of SecurityGroup arrays is defined in config.php also. The first array (1,2) refers to the page security numbers that a user with "Inquiries/Order Entry" access would be authorised to view.\r\n<br /><br />\r\n$SecurityGroups = array(\r\n<br />\r\narray(1,2),\r\n<br />\r\narray(1,2,11),\r\n<br />\r\narray(1,2,4),\r\n<br />\r\narray(1,2,5),\r\n<br />\r\narray(1,2,3),\r\n<br />\r\narray(1,2,3,4,5,6,7,8,9,10,11),\r\n<br />\r\narray(1),\r\n<br />\r\narray(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15)\r\n<br />\r\n);\r\n<br /><br />\r\nThe system continues to evolve and the information set out below may be different in the current version. By default, each page has the variable $PageSecurity defined as follows:\r\n<br /><br />\r\n<table border="2">\r\n<th>Script File Name\r\n<th>PageSecurity value \r\n<tr>\r\n<td>\r\nindex.php\r\n</td>\r\n<td>\r\n1\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustomerInquiry.php\r\n</td>\r\n<td>\r\n1\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nDeliveryDetails.php\r\n</td>\r\n<td>\r\n1\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectOrderItems.php\r\n</td>\r\n<td>\r\n1\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nAccountGroups.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nGLAccounts.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nGLJournal.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBankAccounts.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCOGSGLPostings.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCompanyPreferences.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPaymentTerms.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSalesGLPostings.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryCostUpdate.php\r\n</td>\r\n<td>\r\n10\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPrices_Customer.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPrices.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryAdjustments.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventorys.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryTransfers.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nFreightCosts.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nGoodsReceived.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nLocations.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryCategories.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nTaxAuthorities.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nWWW_Users.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_CreateCompany.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_DeleteCreditNote.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_DeleteInvoice.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_DeleteSalesTransActions.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_index.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_MakeInventoryLocns.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_RePostGLFromPeriod.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_ReverseSuppPaymentRun.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_UpdateChartDetailsBFwd.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_UploadForm.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nZ_UploadResult.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSalesTypes.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nShippers.php\r\n</td>\r\n<td>\r\n15\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nAgedDebtors.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nAgedSuppliers.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nConfirmDispatch_Invoice.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustomerTransInquiry.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nFTP_RadioBeacon.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryPlanning.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryValuation.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nOrderDetails.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPeriodsInquiry.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPO_PDFPurchOrder.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPO_SelectPurchOrder.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPrintCustOrder.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPrintCustStatements.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPrintCustTrans_A4_Portrait.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPrintCustTrans.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSalesAnalReptCols.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSalesAnalRepts.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSalesAnalysis_UserDefined.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectCompletedOrder.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectCustomer.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectProduct.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectSalesOrder.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectSupplier.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nShiptsList.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryMovements.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryStatus.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryUsage.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSupplierInquiry.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBOMInquiry.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBOMListing.php\r\n</td>\r\n<td>\r\n2\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCredit_Invoice.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustomerAllocations.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustomerBranches.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustomerReceipt.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustomers.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPDFBankingSummary.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectCreditItems.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nAreas.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCreditStatus.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSalesPeople.php\r\n</td>\r\n<td>\r\n3\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPO_Header.php\r\n</td>\r\n<td>\r\n4\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPO_Items.php\r\n</td>\r\n<td>\r\n4\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPurchData.php\r\n</td>\r\n<td>\r\n4\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInventoryReorderLevel.php\r\n</td>\r\n<td>\r\n4\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nPayments.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSuppCreditGRNs.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSuppInvGRNs.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSupplierAllocations.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSupplierContacts.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSupplierCredit.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSupplierInvoice.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSuppliers.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSuppPaymentRun.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSuppShiptChgs.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSuppTransGLAnalysis.php\r\n</td>\r\n<td>\r\n5\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBankMatching.php\r\n</td>\r\n<td>\r\n7\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBankReconciliation.php\r\n</td>\r\n<td>\r\n7\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nGLAccountInquiry.php\r\n</td>\r\n<td>\r\n8\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nGLCodesInquiry.php\r\n</td>\r\n<td>\r\n8\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nGLTransInquiry.php\r\n</td>\r\n<td>\r\n8\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nGLTrialBalance.php\r\n</td>\r\n<td>\r\n8\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nSelectGLAccount.php\r\n</td>\r\n<td>\r\n8\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBOMs.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nWorkCentres.php\r\n</td>\r\n<td>\r\n11\r\n</td>\r\n</tr>\r\n</table>', 'S');
INSERT INTO `Help` VALUES (9, 12, '<font size="+2"><b>Setting Up A System</b></font>\r\n<br /><br />\r\nFor the company logo to appear on the each screen, it must be saved in the format of a .jpg file and be copied to the file logo.jpg in the directory with all the other php scripts. The logo needs to have read permissions for the user that the web server is running as normally "nobody" for apache on linux. Permissions issues are a none issue under windows.\r\n<br /><br />\r\nCompany parameters need to be set correctly from the company set up screen. Most of these parameters are self -explanatory. Company name, company number, postal address, physical address etc. Also, telephone numbers and the default home currency of the business. If the default currency is not already set up, then from the main menu system set up tab, the link to the currency maintenance form allows new currencies to be defined and for default rates to be updated.\r\n<br /><br />\r\nThe company record also provides a convenient place to store default GL codes for:\r\n<br /><br />\r\n<ul>\r\n<li>Debtors Control GL Account:\r\n<li>Creditors Control GL Account: \r\n<li>Payroll Net Pay Clearing GL Account:\r\n<li>Goods Received Clearing GL Account:\r\n<li>Retained Earning Clearing GL Account: \r\n<li>Freight Re-charged GL Account: \r\n<li>Exchange Variances GL Account: \r\n<li>Sales Exchange Variances GL Account:\r\n<li>Purchases Exchange Variances GL Account: \r\n<li>Payment Discount GL Account:\r\n</ul>\r\nA default chart of accounts is set up. However, in most cases the company will wish to adopt the chart of accounts it has used traditionally. Chart of accounts maintenance - deletion of accounts and adding of new accounts is done from the General Ledger tab. This would be a starting point for data input of a new system. Where the GL integration features are to be used, setting up the chart of accounts will be a necessary first step.\r\n<br /><br />\r\nThe company record also records the GL integration set up:\r\n<br /><br />\r\n<ul>\r\n<li>Create GL entries for accounts receivable transactions\r\n<li>Create GL entries for accounts payable transactions:\r\n<li>Create GL entries for stock transactions (at standard cost): \r\n</ul>\r\nNotice that the stock GL integration is a separate flag. If GL integration of accounts receivable is set to yes, then GL journals are created for invoices and credits to sales and debtors but not for cost of sales and stock. For the later integration this requires that the GL entries for stock transactions be set to yes also.', 'S');
INSERT INTO `Help` VALUES (10, 119, '<font size="+2"><b>Adding Inventory Items</b></font>\r\n<br /><br />\r\nEntry of new items requires the input of certain base information:\r\n<br /><br />\r\n<ul>\r\n<li>Base information about the Code and description together with the category and item type.\r\n<li>Cost information\r\n<li>Supplier purchasing data\r\n<li>Selling prices\r\n</ul>\r\nEntry of the base information is done from the menu, select the inventory tab and click "Add a New Inventory Item". \r\n<br /><br />\r\n<font size="+1"><b>Item Code</b></font>\r\n<br /><br />\r\nA stock code is required for each stock item, this can be any combination of characters up to 20 characters long. The coding structure of stock items should be considered, to ensure that like stock items appear together. Internally the system looks at the code to order stock items in the various look up tables. A systematic approach to naming stock items can save a lot of time later. Under supplier purchasing data it is also possible to record the supplier\'s part number against an item.\r\n<br /><br />\r\nThere is a script that allows for stock codes to be modified retrospectively, the script goes through all the tables necessary, location stocks, bills of material, order details, purchase order details, sales analysis etc to ensure that all history for the new part code follows the change. The script together with all utility scripts is available from Z_index.php (there are no links to this utility menu - due to the dangerous nature of some of the utilities) The stock code change script itself is named, Z_ChangeStockCode.php.\r\n<br /><br />\r\n<font size="+1"><b>Part Descriptions</b></font>\r\n<br /><br />\r\nA description of the stock item - can be up to 50 characters long. A description is required for each stock item. This description is used in the look up boxes provided each time the stock item is invoiced, credited or adjusted. There is also the facility to enter long descriptions for each part which show on the screens that customers could access to place orders. This field allows very long descriptions or even features and benefits to be described for the item. The intention for this field is that it could be used for producing a company catalogue or for online ordering by customers who may need more information about a product. It is only the description (short) that displays on invoices and credit notes.\r\n<br /><br />\r\n<font size="+1"><b>Categories</b></font>\r\n<br /><br />\r\nThese categories need to be set up first - from the System Setup tab of the menu. In selecting the stock category, be aware that the system uses the category information for analysis and summary reporting as well as identifying accounts for standard cost general ledger integration, if this option is enabled. There is a link to create new stock categories from the stock item entry page.\r\n<br /><br />\r\nA stock category is required for all stock items. The stock category is a text field which groups like stock items together. In selecting stock it is often useful to restrict the search to just the category required. A stock category select box shows on the Select Product screen for this purpose.\r\n<br /><br />\r\n<font size="+1"><b>Unit of Measurement</b></font>\r\n<br /><br />\r\nThis field describes how the stock is to be maintained and is self-explanatory. It is a compulsory field. The selection list is maintained in config.php as an array variable. To add or delete other units of measurement the array variable called $InventoryUnits defined in config.php must be edited by the system administrator.\r\n<br /><br /> \r\n<font size="+1"><b>Economic Order Quantity</b></font>\r\n<br /><br />\r\nThis is the quantity that new orders are made or purchased in by default. Currently this is purely for memorandum - in future this will be a critical part of the MRP calculations.\r\n<br /><br />\r\n<font size="+1"><b>Packaged Volume</b></font>\r\n<br /><br />\r\nThis field is required for freight calculations. It records the volume of the one of the item as packaged for dispatch. See the section on freight calculations.\r\n<br /><br />\r\n<font size="+1"><b>Packaged Weight</b></font>\r\n<br /><br />\r\nThis field is required for freight calculations. It records the weight of the one of the item as packaged for dispatch. The freight calculation takes the higher of the freight costs based on the total weight of the order and the total volume of the order. Most freight companies use a conversion and charge the higher of the two. See the section on freight calculations.\r\n<br /><br />\r\n<font size="+1"><b>Units of Measure</b></font>\r\n<br /><br />\r\nA select box allows the units applicable to the item to be selected from the array of $StockUnits defined in config.php. The unit of measure will show on all invoices and on stock inquiries.\r\n<br /><br />\r\n<font size="+1"><b>Current or Obsolete</b></font>\r\n<br /><br />\r\nIf this field is set to obsolete, this indicates that the stock item is no longer used. However, there may be a stock history on invoices and credit notes which are required. The stock item master record is therefore still required. (Deletion is not allowed while stock movements or Sales analysis records exist for the part) However, it will not appear on searches for invoicing, stock items, in addition the item will be flagged as discontinued in stock reports.\r\n<br /><br />\r\n<font size="+1"><b>Make Or Buy</b></font>\r\n<br /><br />\r\nThis field is compulsory and indicates whether the stock item is:\r\n<br /><br />\r\nManufactured\r\n<br /><br />\r\nPurchased from an external supplier. \r\n<br /><br />\r\nAn assembly of other stock items. An assembly item does not have a physical stock holding itself, nor has it a cost. An invoice for an assembly item creates the stock movements for all the components of the item and the stock of each of the components in proportion to the requirements specified in the bill of material are decremented. The cost of sales entries in the general ledger journals created by an invoice (if the link is active) is created at the sum of the costs of all the items in the bill of material for the assembly as at the time of invoicing.\r\n<br /><br />\r\nA kit set of other stock items that should be exploded into its components when ordered. A kit set is not a physical item itself it is just a short cut to entering a number of parts onto an order. Unlike an assembly, the kit set part does not appear on invoices or orders, but "explodes" into its component parts for modification. It follows that kit sets do not have any cost or physical stock quantities associated with them.\r\n<br /><br />\r\nA dummy item that has no physical stock associated with it.\r\n<br /><br />\r\nThis field is relevant for MRP and production scheduling. This field can also be set to Dummy Inventory Item - which then disables stock quantity tracking at the locations and in total. Dummy stock items are used for invoicing services and labour or even physical items which do not require tracking. The stock movement records are still created and are available to recall on invoicing and credit note inquiries. Inventory adjustments are not allowed for Dummy Inventory Items. Assembly items can have sales analysis records created for them, but no stock quantity is maintained and stock movement records are created for the components. Assemblies would normally be used where the warehouse keeps the components of the item for several different purposes and only assembles the items as they are picked for dispatch.\r\n<br /><br />\r\n<b>Setting Up Assembly Items</b>\r\n<br /><br />\r\nUsing the example of toilet suites, where the business wishes to keep track of how many sold - i.e. The sales analysis - but only wishes to track the quantities of stock held of the toilet pans and toilet cisterns that make up the suite.\r\n<br /><br />\r\nThe business will never want to hold stock of made up suites, when stock is counted only cisterns and pans are counted not suites. If there are any made up suites these would need to be broken down into their components and the components included in the stock counts.\r\n<br /><br />\r\nSuch parts are called "Assembly" items by the system.\r\n<br /><br />\r\nWhen an assembly item is invoiced, the stock of the components of the assembly are decreased by the quantity in its bill of material multiplied the number of the assembly item sold.\r\n<br /><br />\r\neg. A suite that has 2 screws in it to screw the pan to the floor might have a bill of material:\r\n<br /><br />\r\n1 x cistern\r\n<br />\r\n1 x White S trap pan\r\n<br />\r\n2 x Pan screws\r\n<br />\r\n1 x pan pac carton\r\n<br /><br />\r\nIf the sale was for 10 of these - the stock of the cistern, pan and pan-pac cartons would be reduced by 10 and the stock of the pan screws would be reduced by 20. The stock movement inquiry shows this movement and the reference to the assembly item that it came from and the invoice number it was sent out on.\r\n<br /><br />\r\nIt is important to remember that when an assembly item is credited this process happens in reverse - stock is booked back into the components in exactly the same way as it is invoiced out. The credit note must be entered against the correct stocking location otherwise the pan and cistern stocks in the location where the stock did get returned to and the location where the credit note was entered to will be wrong. There is facility to write the stock off at the time of credit note entry also - in this case the stock location is not important.\r\n<br /><br />\r\nThis next point is a little confusing. The system also shows the movement of assembly items in the movement inquiry for the assembly item itself. This does have the advantage of showing to whom the assembly items have been sold at a glance. However, there are no stock status inquiries for assembly items since they are not stocking items (only the components are held and picked to make up the assembly item at the time of dispatch).\r\n<br /><br />\r\nWhen parts are first set up - the description and stock category needs to be defined and it is at this point that the type of item is defined - from the heading on that screen titled - "Make, Buy, Kit, Assembly or Dummy Part". The choices are "purchased" - the default, "manufactured", "assembly", "kit-set" or "dummy". \r\n<br /><br />\r\nConsidering the treatment of assembly items:\r\n<br /><br />\r\nIf there is stock of an item as shown on the stock status screen - then it is NOT possible to convert the item to an assembly by changing this flag - the stock must first be adjusted back to nil and the corresponding component stock adjusted up. Also, if there are purchase orders for the item - it cannot be converted to an assembly. Remember the assembly part does not exist as a separate part only as an assembly of real stock items for the purposes of selling.\r\n<br /><br />\r\nHaving set the part to be an assembly, then the part will show an option on the "Select Item" menu to show the costed bill of material. This inquiry shows the current Bill Of Material (BOM) for the assembly together with the cost of each of the components and the total of the costs that is used in the sales analysis and general ledger postings.\r\n<br /><br />\r\nSetting up an assembly part requires setting up A Bill Of Material - BOM for the item.\r\n<br /><br />\r\nFrom the manufacturing tab of the main menu - under the Maintenance section - click the link "Bill Of Material Maintenance". The item search fields show with the option to enter either an extract from the item description or the item code. Having entered the selection click on the "Search Now" button. Not all items will show - only those items that can have a BOM - assembly items, manufactured parts and kit-sets. If the part is not defined as an assembly item - it won\'t show up! \r\n<br /><br />\r\nClicking the part code button will then show a screen for entering components to make up the BOM. If a BOM already exists for the item it will show the components already set up. There are two links next to each item shown in the current BOM to enable the line to be edited or deleted.\r\n<br /><br />\r\nTo enter a new component into the BOM for an assembly, all that is required is to select the component code from the list - the location and work centre are not used for assembly items so the default can be accepted as is. (The location specified in the sales order is used for all the assembly components stock entries.) The quantity required of the component for each assembly item is required to be entered - it defaults to 1 (and maybe 1 in most cases).\r\n<br /><br />\r\nThe effectivity dates - effective to and effective after (also known and engineering change control dates) are the dates between which the component is used in the assembly. If the BOM is due to change and customers have been advised that a new pan will be used in suites effective from 1 Jan 05 then the new pan could be entered as a component from that date. The existing pan effective to would have to be changed to be effective to 31 December 04. The alternative is to change all the BOMs on the day when the change is made.\r\n<br /><br />\r\nOnce the component fields have been entered hitting the enter information button adds the component to the BOM there and then. When the BOM is complete just navigate to the main menu of other link to the next task. Be careful not to click enter information button on the default component by mistake - the component must be selected from the list first.\r\n<br /><br />\r\n<font size="+1"><b>Controlled</b></font>\r\n<br /><br />\r\nThis field denotes whether the item is to have lot control on it. Lot control is known by several terms including, batch control, bundle control, roll control. In short it allows a reference for each batch of the item to be entered at the time of delivery, transfer, stock check, invoicing etc. When booking in controlled items the batch references and the quantities in each batch must be entered. Many quality control systems that require traceability of raw materials need this functionality to establish what batch of raw material was used in a given work order. Or what roll of cloth was sold to a given customer. Other industries call their lots of product by different names a melt, a cut, a run etc. Every time a transaction involving a controlled item is created, the system will accumulate the quantity from a separate form for selecting the batches (Lot/roll/melt/work order/serial numbers).\r\n<br /><br />\r\n<font size="+1"><b>Serialised</b></font>\r\n<br /><br />\r\nSerialised is a special case of controlled where the batch size is always one. The system will prompt for the serial number of each item of stock being received and stock records will be maintained for all serial numbers separately. Serialised does not have any effect if controlled is not set.\r\n<br /><br />\r\n<font size="+1"><b>Bar Code</b></font>\r\n<br /><br />\r\nThis field is the unique identifying bar code for this item, typically containing the EAN bar code for the item. This field is used in identifying the item in EANCOM  edi messages.\r\n<br /><br />\r\n<font size="+1"><b>Discount Category</b></font>\r\n<br /><br />\r\nIs used in the discount matrix of discount categories and sales types. When an order is for an item with a discount category code and a customer of a sales type that has a discount matrix entry and the order is for a quantity more than the matrix quantity break figure, the system automatically enters the discount into the order lines for all items in that discount category. This allows quantity break discounts across a range of similar products.\r\n<br /><br />\r\nThe discount category is a 2 character field and there is no error checking on entries.\r\n<br /><br />\r\n<font size="+1"><b>Decimal Places</b></font>\r\n<br /><br />\r\nSome items of stock require a number of decimal places to be retained and displayed, others do not require any. This field is used throughout the system for invoices, orders and all places where the item quantity is displayed.', 'S');
INSERT INTO `Help` VALUES (11, 104, '<font size="+2"><b>Inventory Costing</b></font>\r\n<br /><br />\r\nFrom the menu select the inventory tab and Modify Standard Costs. The item code can be entered directly to show the current cost structure, modifications to costs in this screen are reflected in standard cost journals in the general ledger if the link is active in the Company Preferences page - (menu - System Setup tab). Alternatively, to select the stock item to modify the costs for the costing page can be called from the Select Item page - once an item has been selected - a link to the Select Item page is shown on the title bar of all pages. Maintenance and initial entry of cost data is a critical part of the system set up. Simply defining the item header is not sufficient on its own. The cost information entered here is used for both inventory valuation reports and for the general ledger integration stock journals created for the cost of sales, the cost value of stock adjustments, the value of stock received and so on. It can be omitted only if the user is not interested in the value of stock and no general ledger - stock integration is required.\r\n<br /><br />\r\n<font size="+1"><b>Material Cost</b></font>\r\n<br /><br />\r\nIf the item is bought in, this field should be the average or expected cost of the item. If the item is manufactured in house, it should be the cost of externally sourced materials plus the total cost of in house manufactured components, from lower levels in the bill. In future this will link to the Bill Of Materials cost roll up. Alterations to this figure affect the value of all stocks of this item held. The system is a standard costing system. When items are purchased the actual purchase cost is compared to this figure and a variance reported to the general ledger account set up in the stock categories record applicable to the item.\r\n<br /><br />\r\n<font size="+1"><b>Labour Cost</b></font>\r\n<br /><br />\r\nThis field should be the total standard cost of labour included in the cost of this stock item. The labour cost is the labour applicable only to this part not to the manufacture of components at a lower level in the bill of materials. The labour cost of componentry would be included in the material cost. Alterations to this figure affect the stock value of all stock held. See comments for Material Cost. In future, this field will be altered automatically on roll ups of cost.\r\n<br /><br />\r\n<font size="+1"><b>Overhead Cost</b></font>\r\n<br /><br />\r\nThis field should be the total overhead to be recovered on the sale of 1 unit of the stock item. Its value affects the value of all stock held of this item, as for labour cost and material cost above. Labour cost, Material cost and Overhead cost are all added together to get the total cost standard cost of a stock item. This total is the value applied to stock valuations. In future, the cost roll up will automatically update this field based on the work centre overhead rates and the quantity of labour at each work centre.\r\n<br /><br />\r\n<font size="+1"><b>Standard Costing Considerations</b></font>\r\n<br /><br />\r\nEach time a stock item is sold, the cost of sales account (specified by the COGS GL Postings table by reference to the stock category and sales area of the branch) is updated with the total of material cost, labour cost and overhead cost, and the stock value (the account specified in the stock category record) is decreased by the total standard cost. \r\n<br /><br />\r\n<font size="+1"><b>Actual Cost</b></font>\r\n<br /><br />\r\nThe actual cost is the last purchased cost as updated by the system on a purchase. For a manufactured item this is the actual cost as calculated including only efficiency variances (price variances are excluded)\r\n<br /><br />\r\n<font size="+1"><b>Alterations To Labour Cost, Material Cost or Overhead Cost</b></font>\r\n<br /><br />\r\nSince the system only maintains the one standard cost of items, this is the cost that stocks are valued at. In altering this cost all stock held of the stock item under review will be re-valued or devalued accordingly. If stock journals are being created (the option is set in the company preferences from the System Setup tab) then a system generated journal will be created for the effect on stock value using the general ledger accounts set up for the stock category currently defined for the stock item being changed.\r\n<br /><br />\r\nOnly transactions entered after the charge will be created at the new cost. Sales analysis will refer to the costs as at the time when the transactions are created.\r\n<br /><br />\r\nThere is a utility available from the Z_index.php page that allows the sales analysis for a specified period to be updated with the current costs. This utility takes the quantity sold and multiplies the current standard cost by the quantity to re-calculate the cost of each sales analysis record in the period selected - the sales analysis data is updated. This will mean that the general ledger costs will then differ to the sales analysis cost for the period since the general ledger postings are created at the time of invoicing/crediting.', 'S');
INSERT INTO `Help` VALUES (12, 91, '<font size="+2"><b>Selecting Inventory Items</b></font>\r\n<br /><br />\r\nFrom all pages in the system the main title bar has links to select from the critical tables in the system. Customers, inventory and suppliers. Clicking on the "Select Item" link takes the user directly to the inventory item selection page. In addition, from the menu, the Inventory tab has a link to "Modify or Delete an Inventory Item Or Maintain Pricing". Using either method, the select item or product page will show.\r\n<br /><br />\r\nThe search for a particular item can be narrowed by selection of a specific stock Category - a select box allows selection of the category. Also if some element of the code is known this can be entered, alternatively if some element of the description is known this can be entered - the description keywords are used if both a code and description fields are used. Note that the text entered into these fields does not have to be the start of the code or the description. All items with the text anywhere in either the code or the description respectively will be displayed, together with the total stock on hand and the unit of measure for the item. Assembles, kit-sets and dummy parts will all show zero stock on hand. \r\n<br /><br />\r\nThe maximum number of resultant items can be defined by a parameter in config.php - this limits the number of records returned so that users over a lower bandwidth connection are not penalised for making too wide a selection. Downloads of significant amounts of data over a slower dial up connection would result in serious degradation in performance. By default this is set at 100 items.\r\n<br /><br />\r\nClicking on the button of the code of the item that is required will select it and links to the options applicable to the item will be displayed. \r\n<br /><br />\r\nHaving selected an item it is possible to modify:\r\n<br /><br />\r\n<ul>\r\n<li>Item master information\r\n<li>Costs\r\n<li>Pricing\r\n<li>Reorder levels \r\n<li>Purchasing data\r\n</ul>\r\nIt is also possible to inquire on:\r\n<br /><br />\r\n<ul>\r\n<li>Inventory Movements\r\n<li>Status - showing quantity on hand, on order with suppliers and on sales orders for customers by location\r\n<li>Historical usage by month\r\n<li>Outstanding sales orders\r\n<li>Outstanding purchase orders\r\n<li>Completed sales orders\r\n<li>Bill of Material\r\n</ul>\r\nFurther it is possible to initiate transactions to:\r\n<br /><br />\r\n<ul>\r\n<li>Transfer stock between locations\r\n<li>Adjust stock quantities on hand.\r\n</ul>\r\nAt the bottom of this page, there is also a link to perform a fresh search for a different item.', 'S');
INSERT INTO `Help` VALUES (13, 119, '<font size="+2"><b>Amending Inventory Items</b></font>\r\n<br /><br />\r\nThe master information is available for amendment. The only field that cannot be altered on the main stock item page, is the code. The code is used in many tables throughout the system and modification of the stock code would require data in many other tables of information to make corresponding changes. A special utility is available that allows stock code changes to be made. The changes to the database are extensive and it is recommended that this facility be run out of normal operating hours since the load on the server for the changes could be substantial in a large database. See special utilities. The following points should be considered when altering data fields:\r\n<br /><br />\r\n<font size="+1"><b>Changing a Category</b></font>\r\n<br /><br /> \r\nThe Category of a stock item can be altered at any time. \r\n<br /><br />\r\nHowever, if the stock journals option is active (in the company preferences set up), it should be remembered that the general ledger coding set up for that category can not be amended retrospectively. In other words, general ledger journals created for invoices, credit notes and stock adjustments created using the old category general ledger codes cannot be altered. The general ledger coding could be amended with a manual journal if necessary.\r\n<br /><br />\r\nNote: Sales analysis done by Inventory Category is performed with the stock categories as they were when the invoice/credit was created. Inventory Category information is stored in the sales analysis table and cannot be changed retrospectively.\r\n<br /><br />\r\n<font size="+1"><b>Alterations to the Make or Buy Flag</b></font>\r\n<br /><br />\r\nA stock item that currently has stock cannot be changed to a Dummy stock item, an Assembly item or a kit set item. The system does not maintain stock quantities for these items and it is therefore inappropriate to have an initial stock quantity. The stock must be either invoiced, credited or adjusted to zero for all locations before this can be changed. Similarly, the system will only allow a Bill of Material to be set up for manufactured, assembly or kit set items. Altering a manufactured item (or assembly or kit set) which currently has a Bill Of Material to a purchased item is also disallowed, the BOM must be deleted first.', 'S');
INSERT INTO `Help` VALUES (14, 102, '<font size="+2"><b>Inventory Categories</b></font>\r\n<br /><br />\r\nInventory Categories are the natural groupings which apply to certain types of stock. A business will normally have several distinct categories. E. g. A manufacturing jeweller might have stock categories for gold chain, silver chain, diamonds, rubies etc.\r\n<br /><br />\r\n<font size="+1"><b>Inventory Category Code</b></font>\r\n<br /><br />\r\nThis is a six character text field which is the reference used internally by the system. The category code must be unique between different categories. It cannot be changed retrospectively and cannot be deleted where stock items are set up to use the category, or sales analysis records exist using the category. The category code is stored against sales analysis records for reporting. All stock items must be defined as belonging to a category and has the appropriate category code stored against it in the StockMaster table.\r\n<br /><br />\r\n<font size="+1"><b>Inventory Category Description</b></font>\r\n<br /><br />\r\nThis description is used in searches for stock items and in sales analysis reports to describe the category of stock referred to. Up to 20 characters of text can be entered, although on some reports less than the full description will appear. \r\n<br /><br />\r\n<font size="+1"><b>Balance Sheet Inventory GL Account</b></font>\r\n<br /><br />\r\nThis is the general ledger account where system-created standard costing journals will post the balance sheet entry. It is possible to set up a GL account for each stock category or to post all raw material stock categories to a raw material general ledger account and similarly for finished goods stock categories. The select box lists all the available balance sheet accounts - profit and loss accounts will not show. If a new general ledger account needs to be set up this should be done first. This field will not be used if the company preferences flag for "Create GL entries for stock transactions (at standard cost)" is not enabled.\r\n<br /><br />\r\n<font size="+1"><b>Inventory Adjustments GL Posting Account</b></font>\r\n<br /><br />\r\nThis is the general ledger account where the system created standard costing journals will post the profit and loss entry to for stock adjustments. It can be different for any or all stock categories. The select box lists all available profit and loss accounts. This field will not be used if the company preferences flag for "Create GL entries for stock transactions (at standard cost)" is not enabled.\r\n<br /><br />\r\n<font size="+1"><b>Purchase Price Variance Account</b></font>\r\n<br /><br />\r\nThis general ledger account is used by accounts payable invoice entry to post variances between standard cost and the actual cost of stock items of this category. Price variances are calculated when the purchase invoice is entered, unless the purchase order item is on a shipment. Shipment purchase price variances are calculated when the shipment is closed. This field will not be used if the company preferences flag for "Create GL entries for stock transactions (at standard cost)" is not enabled.\r\n<br /><br />\r\n<font size="+1"><b>Material Usage Variance Account</b></font>\r\n<br /><br />\r\nNOT YET IMPLEMENTED: \r\n<br /><br />\r\nThis general ledger account is used by the works orders to post the variances between the actual material issued to a work order and the standard requirements of the work order based on the number of finished items resulting from the work order. This field will not be used if the company preferences flag for "Create GL entries for stock transactions (at standard cost)" is not enabled.\r\n<br /><br />\r\n<font size="+1"><b>Type of Resource</b></font>\r\n<br /><br />\r\nNOT YET IMPLEMENTED: \r\n<br /><br />\r\nThis field declares the type of resource that the stock category represents and is one of Finished Goods, Raw Materials, Labour or Dummy Inventory. This field is used to distinguish labour type stock items from other components for the purposes of calculating work centre overhead in the cost roll up. It is also used for ordering stock reports to ensure raw materials and finished goods are grouped together.', 'S');
INSERT INTO `Help` VALUES (15, 48, '<font size="+2"><b>Inventory Location Maintenance</b></font>\r\n<br /><br />\r\nA table of locations is maintained which contains a location code of 5 characters and the location description (up to 20 characters). The description is the field used in lookups on invoicing and crediting. To keep the database as compact as possible it is the code which is stored against stock movement transactions. As many locations as required can be set up. When a new location is defined, location records for all items in the database are created. When a location is deleted, so too are all the item location records. However, a location record cannot be deleted if there are stock movements or stock held for any part in the location. Since the location represents the physical location from where goods/services are supplied it is important for determining the tax applicable on a sale. The governing tax authority must specified with the location record. It is used in the calculation of the applicable rate of tax in conjunction with the tax authority of the customer branch being delivered to and the tax level of the item being sold.\r\n<br /><br />\r\nNote: Location codes cannot be modified retrospectively. Neither can they be deleted if there are stock movements, users (default location) or customer branch records set up to receive stock from the location.', 'S');
INSERT INTO `Help` VALUES (16, 100, '<font size="+2"><b>Inventory Adjustments</b></font>\r\n<br /><br />\r\nInventory can be written on or off for individual stock items using this option. Corrections to physical stocks and deliveries of stock can be entered using this option. Adjustments can be entered by selecting the link on the SelectProduct.php page or directly from the menu under transactions. Using the second link, the item code must be known, there is no facility to select an item code from this page. \r\n<br /><br />\r\nIf Stock GL integration is enabled from the company preferences page (under the setup tab), then the system creates the necessary journals in the general ledger to update the stock account and the profit and loss account stock adjustment account specified in the stock category record. (see Inventory Categories above and also see General Ledger Integration later)\r\n<br /><br />\r\nNote: Inventory Adjustments are not possible with kit set, assembly or dummy stock items since no stock record is maintained for these items.\r\n<br /><br />\r\nInventory adjustments for controlled items must select the batches/serial numbers being adjusted.', 'S');
INSERT INTO `Help` VALUES (17, 117, '<font size="+2"><b>Inventory Location Transfers</b></font>\r\n<br /><br />\r\nTransfers of inventory between locations need to take stock off the sending location and increase the stock in the receiving location. This is effected in one transaction by entering a stock transfer. In the same way as adjustments these can be accessed either from the SelectProduct.php page which is linked to from every page on the top header banner or directly from the menu - inventory tab under the transactions section. All that is required is the location from and to, the date and the quantity being sent. If the business wishes to record inventory in transit an additional in transit location needs to be established and a transfer to the transit location performed when the stock is dispatched and a further location transfer from the transit location to the receiving location when the stock is received. Stock location transfers are shown on stock movement inquiries.\r\n<br /><br />\r\nNote: Inventory Location Transfers are not possible with kit set, assembly or dummy stock items since no stock record is maintained for these items.\r\n<br /><br />\r\nBulk inventory transfers consisting of many parts can be set up effective from 2.9. These allow a docket to be produced to be sent with the dispatch of the goods. The transfer is not actually effected until the transfer is received in by the receiving stock location.', 'S');
INSERT INTO `Help` VALUES (18, 115, '<font size="+1"><b>Inventory Status inquiries</b></font>\r\n<br /><br />\r\nShows the detail of how much stock is held and where the stock is (i.e. how much at each location) together with the total quantity of sales orders for the part outstanding and the quantity of the item on outstanding purchase orders can also be viewed from this inquiry. Not only are outstanding sales orders for this part accumulated but all the demand for parent assembly parts as extended by the quantity required per unit of the parent. This ensures that all demand for the part is shown.\r\n<br /><br />\r\nThis - and all stock inquiries are called from the SelectProduct.php page - this page is linked to from every page in the system from the header links "Select Item". Once an item is selected the relevant inquiry options are displayed. As  with all web pages produced by the system most browsers have good facilities to print them. \r\n<br /><br />\r\nIf the item selected is a controlled item then the status inquiry will also show a link to show the batches. If the item is serialised, the link will refer to the serial numbers rather than batches. ', 'S');
INSERT INTO `Help` VALUES (19, 111, '<font size="+1"><b>Inventory Movement inquiries</b></font>\r\n<br /><br />\r\nInventory movements for the item show with the most recent movements at the top of the screen in descending order of date.\r\n<br /><br />\r\nThis inquiry shows the movements of the stock item for a specified location with further links to the transaction detail that created the movements such as the invoice or credit note. By default only the last 3 months stock movements show but the date from which stock movements are displayed can be modified from the inquiry page.\r\n<br /><br />\r\nNote: Inventory movement inquiries are possible on dummy and assembly stock items. However, since dummy items are not physical stock items, no record of the amount of stock and the location of where held (there is none held) are maintained. The location inquiry will always be zero for a dummy/assembly and kit set items. When a dummy stock item, or an assembly or kit set item is selected the link to the stock status inquiry is not available.\r\n<br /><br />\r\nIf the stock movement was an invoice or a credit the customer and the price in the currency invoiced or credited will show. ', 'S');
INSERT INTO `Help` VALUES (20, 118, '<font size="+1"><b>Inventory Usage inquiries</b></font>\r\n<br /><br />\r\nThis inquiry shows the quantity of the stock item that has been consumed either in sales net of credit notes and adjustments by month from each location. Transfers between locations are ignored as are deliveries. Usage of an item adds all the stock movement quantities for the part so that stock movements related to the sale of assembly items requiring the part under review as a component are included. Usage can be seen by location and also the total usage from all locations.\r\n<br /><br />\r\nThere is a user modifiable flag which determines how many months of stock usage should be maintained for the item.', 'S');
INSERT INTO `Help` VALUES (21, 47, '<font size="+1"><b>Inventory Valuation Report</b></font>\r\n<br /><br />\r\nThis report shows the stock on hand at the time the report is run as extended at the current standard cost. Both reports show the total quantity of stock held by Location and by Inventory Category. The detail report lists the individual stock items and value of each. Inventory items with no stock on hand are not printed out. This report can be run with only a selected inventory category and location, to reconcile the stock general ledger accounts.\r\n<br /><br />\r\nA separate script is included in the distribution that can be set to run the stock listing report and email it to predetermined email addresses. To take advantage of this facility, the script must be called by wget under a linux distribution from a crontab entry on the last day of each month. The script is called MailInventoryValuation.php. This script will need to be edited with the email address of the user to receive the report and any parameters necessary to run the report. By default it produces a detailed report for stock at all locations. The entry in crontab in a linux installation that would send the report at 0:0 on the first day of each month (assuming wget is installed in /usr/bin/wget and that the web server is on the same machine) would be:\r\n<br /><br />\r\n# Scheduled email of monthly Inventory Valuation report\r\n<br /><br />\r\n-0 0 1 * * root /usr/bin/wget <a href="http://localhost/web-erp/MailInventoryValuation.php">http://localhost/web-erp/MailInventoryValuation.php</a>\r\n<br /><br />\r\nsince the page has no output - it would be pointless running it in a web browser although it would initiate another email to the defined recipients.', 'S');
INSERT INTO `Help` VALUES (22, 46, '<font size="+1"><b>Inventory Planning Report</b></font>\r\n<br /><br />\r\nThis report shows the usage of stock items over the previous four months together with the current stock, outstanding sales orders and outstanding purchase orders. It suggests a re-order quantity based on a number of months times the maximum of the previous four months monthly stock usage (from all stock locations), less the on hand stock and purchase orders. It will not suit all purposes but certainly does provide good information from which to base purchasing decisions.\r\n<br /><br />\r\nThe Inventory Planning Report is run from the Inventory tab of the main menu under the Inquiries and Reports section.', 'S');
INSERT INTO `Help` VALUES (23, 103, '<font size="+1"><b>Inventory Checks</b></font>\r\n<br /><br />\r\nScripts are available to automate the stock check adjustments necessary following a stock check. However, this feature does not work with controlled items .... yet. The procedure for there use and for stock checks in general is as follows:\r\n<br /><br />\r\n<b>Step 1:</b>\r\n<br /><br />\r\nEnsure invoicing is complete for all product dispatched.\r\n<br /><br />\r\n<b>Step 2:</b>\r\n<br /><br />\r\nFrom the main menu - inventory tab, click on the link to print out the stock check sheets.\r\n<br /><br />\r\nThis page allows selection of the stock location to be checked and a range of stock categories to check. Note there is a new field called:\r\n<br /><br />\r\nAction for stock check freeze. \r\n<br /><br />\r\nBy default this is set to list the items to be counted. Before a stock starts this must be run selecting " make a new stock check data file". This copies the quantities on hand as at the time the report is run. If the stock check sheets are run for another location and it is set again to make a new stock check data file, then the previous stock check data file is over-written and lost. If there is a stock check in progress in one location and another location wishes to initiate one too, then the second person to run the stock check sheets needs to print them with the Action for Stock Check Freeze field set to Add/update existing stock check file. Similarly if another stock category is to be added to the stock check then - Add/update existing stock check file is the correct option.\r\n<br /><br />\r\n<b>Step 3:</b>\r\n<br /><br />\r\nOnce the stock check data file is created - the stock should be counted.\r\n<br /><br />\r\n<b>Step 4:</b>\r\n<br /><br />\r\nThe counts should be entered - the system will only accept count entries for parts that were included in the categories selected for stock taking in step 2. The system allows many counts for each item and totals all counts to work out the required adjustment. Also, the initial of the counter or reference to the count sheet can be entered to provide a trail of where the stock was that is entered. As soon as there are counts to enter - the counters should pass on the count sheets to the data entry team so that the data entry can be completed as soon as possible after the counting is complete.\r\n<br /><br />\r\n<b>Step 5:</b>\r\n<br /><br />\r\nHaving completed the entry of the counts the Comparison report can be run. \r\n<br /><br />\r\nThis is run from the Inventory tab of the main menu:\r\n<br /><br />\r\nCompare Counts Vs Stock Check Data\r\n<br /><br />\r\nThere are number of options for running this report. The default is to run the report without making any adjustments. It should be run in this mode initially so that a review of the proposed adjustments is undertaken. Any adjustments that seem incorrect can now be double checked (i.e. counted again) as necessary.\r\n<br /><br />\r\n<b>Step 6:</b>\r\n<br /><br />\r\nOnce happy that the adjustments to be made are correct the report can be run again with the option to Report and Close the Inventory Comparison File and Process Adjustments as Necessary. \r\n<br /><br />\r\nThere is no going back on this process - if you didn\'t mean to process these adjustments they must all be reversed manually. Be very sure when running the comparison in this mode.', 'S');
INSERT INTO `Help` VALUES (24, 26, '<font size="+2"><b>Entering New Customers</b></font>\r\n<br /><br />\r\nFrom the menu Receivables tab, click on "Add A New Customer". The customer record is the actual charge account, any number of branches can be defined for each customer account. At least one branch must be defined for each customer. It is the branch details that record the local information about delivery address, tax authority, sales area and sales person.\r\n<br /><br />\r\n<font size="+1"><b>Customer Code</b></font>\r\n<br /><br />\r\nThis field is used as a unique identifier for the customer which is small (maximum of 10 characters of text - letters or numbers). This allows faster searches for customers and keeps the size of the database at a minimum. \r\n<br /><br />\r\nNote: A customer code can be altered retrospectively but because of the large scale of the changes required to the system to update stock movement transactions, sales analysis records and sales orders it could present a significant drain on resources. The option to change a customer code is in the utility menu Z_index.php - which must be entered as a manual URL and is only accessible by the system administrator. Such changes should only be undertaken when there are no other users on the system.\r\n<br /><br />\r\n<font size="+1"><b>Customer Name</b></font>\r\n<br /><br />\r\nThe name of the customer is used extensively in lookups and appears on invoices and statements exactly as typed (searches are independent of case). Proper capitalisation and use of the full name of the customer is recommended. The maximum length of the name is 40 characters.\r\n<br /><br />\r\n<font size="+1"><b>Address Line 1, 2, 3 and 4</b></font>\r\n<br /><br />\r\nThis is the address of where invoices and statements are to be posted. A post office box should be entered if applicable. These fields will allow a maximum of 40 characters and are optional. If left out invoices will not show the customer\'s address which is a requirement for a valid GST or VAT invoice in some administrations. \r\n<br /><br />\r\n<font size="+1"><b>Currency</b></font>\r\n<br /><br />\r\nThis is a compulsory field that identifies the currency in which the customer is to be invoiced. All invoices created for the customer will use this currency and the rate will be used as set up in the currency master - accessible from the General Ledger module. The currency rates need to be maintained at least monthly.\r\n<br /><br />\r\nNote: that the rate is recorded in the transaction not the currency. If a customer changes the currency in which they are invoiced it is possible to allocate a new currency receipt against invoices (invoiced in the old currency) in which case the system will calculate large differences on exchange. Note: There is no error check on this and care should be taken, should this occur, to ensure invoices are matched off in the currency in which they were originally created - the cross rate between the new and old currency will provide an equivalent amount of the old currency for entry and allocation.\r\n<br /><br />\r\n<font size="+1"><b>Invoice Discount</b></font>\r\n<br /><br />\r\nCustomers can be set up with a general level of discount which applies to all sales. The percentage entered is used by default on all invoices to the customer. The discount rate can be manually overridden at the time of invoicing, which the system will use to calculate discount. The discount percentage used at invoice time will not be stored as the future default unless the customer details are amended. This field checks to ensure that the percentage is less than 100% and greater or equal to zero. \r\n<br /><br />\r\nThis feature is not currently used/implemented.\r\n<br /><br />\r\n<font size="+1"><b>Prompt Payment Discount</b></font>\r\n<br /><br />\r\nCustomers can be set up with individual prompt payment discount percentages. This field is for memorandum purposes only and shows on screen when customer receipts are entered. If the receipt is on time the discount can be calculated and input with the receipt.\r\n<br /><br />\r\n<font size="+1"><b>Customer Since</b></font>\r\n<br /><br />\r\nThe default is the current date. This field is only used on certain reports where it can be used to restrict the customers shown, and also for credit reference inquiries. The system will only accept a date in this field. The date can be altered at any time. There is no error checking on this field.\r\n<br /><br />\r\n<font size="+1"><b>Payment Terms</b></font>\r\n<br /><br />\r\nA select box is provided showing the predefined payment terms. New ones can be created as necessary from the Setup tab of the menu. The terms are used to determine whether an account is overdue or not and a description of the terms prints out on invoices, and statements.\r\n<br /><br />\r\nThere are no restrictions on altering payment terms for a customer at any time. The next statement or invoice produced will show the new terms. The system will only look at the new terms in deciding whether or not invoices are overdue, no record of the terms is held in the transaction itself. \r\n<br /><br />\r\n<font size="+1"><b>Credit Status or Rating</b></font>\r\n<br /><br />\r\nA lookup is available for this field and a button is available for creation of new credit status categories. Credit status\'s can be defined to stop any new invoices or indeed orders to the customer - irrespective of his/her credit limit.\r\n<br /><br />\r\nA customers Credit Status can be altered at any time. \r\n<br /><br />\r\nNote: This will never show on any reports invoices, credits or statement intended for the customers eyes.\r\n<br /><br />\r\n<font size="+1"><b>Credit Limit</b></font>\r\n<br /><br />\r\nThis is a required field which accepts any positive value. It is currently only for memorandum purposes.\r\n<br /><br />\r\n<font size="+1"><b>Invoice Addressing</b></font>\r\n<br /><br />\r\nThis field is a flag that has two choices:\r\n<br /><br />\r\n<ul>\r\n<li>To address invoices to the head office postal address. This is the postal address from the customer record as entered above. This is the default option.\r\n<li>To address invoices to the branch postal address. This addresses invoices charged to the customer to the branch of the customer, some customers may wish for the branch to authorise invoices before sending on to head office for payment. The branch postal address entered will be used for printing invoices.\r\n</ul>', 'S');
INSERT INTO `Help` VALUES (25, 26, '<font size="+2"><b>Amending Customer Details</b></font>\r\n<br /><br />\r\nThe customer details can be modified at any time and any modifications made will be effective for all future transactions. First select the customer from the link provided on all pages, then select the link for Modify Customer Details. \r\n<br /><br />\r\nPoints to note:\r\n<br /><br />\r\n<ul>\r\n<li>Customer codes can be modified retrospectively using the facility in the utilities menu Z_index.php - this should be used only when all other users are off the system.\r\n<li>Changing the payment terms impacts immediately on the aged analysis since this is recalculated each time it is run or a statement is produced.\r\n<li>Changing the currency of the customer needs care since the exchange rate is recorded against each transaction. Allocations of one currency against another at different rates will produce differences on exchange. The system will not be able to distinguish at the transactions level which was in what currency only the rate against the functional currency.\r\n</ul>\r\n<font size="+2"><b>Salesperson Records</b></font>\r\n<br /><br />\r\nSalesperson details can be entered or amended from the setup tab of the main menu.\r\n<br /><br />\r\n<font size="+1"><b>Salespeople Code</b></font>\r\n<br /><br />\r\nThis field can accept any text or numbers up to a maximum of 3 characters - normally the initials of the salesperson or some reference to the area NW1,SW2 would suffice. These salespeople codes are stored against each branch to identify who services them. actual\r\n<br /><br />\r\nNote: The salesperson code is not held against individual transactions. This means that if there is any change to a salesperson for an area and you wish to calculate commissions up to the change and after for the new salespeople, the dates of transactions must be used. However, sales analysis records created at the time of invoicing and crediting are created including a copy of the salesperson code applicable at the time of invoicing. Sales analysis reports will thus show who made sales based on the historical representative settings.\r\n<br /><br />\r\n<font size="+1"><b>Salesperson Name, Telephone and Fax Numbers</b></font>\r\n<br /><br />\r\nThe salesperson name is what appears in the look-ups on the customers\' branch maintenance page. It is also used for inquiries and reports. By default it shows on invoices and statements, to remind customers where they can contact their local agent for sales inquiries.\r\n<br /><br />\r\nThe name can be any character to a maximum of 30 characters. The phone number and fax number fields can be a maximum of 20 characters long. \r\n<br /><br />\r\n<font size="+1"><b>Salesperson Commission Rates and Breakpoint</b></font>\r\n<br /><br />\r\nThe system allows for input of these items as the basis of commission calculations. Most businesses have different ways of calculating commissions. For this reason it is left to the business to write a report which will use these fields (and/or additional ones) to calculate commission according to traditional company policy.\r\n<br /><br />\r\n<font size="+2"><b>Sales Types/ Price Lists</b></font>\r\n<br /><br />\r\nSales types are the broad categories which sales fall under, they should not be confused with stock categories. They are arbitrary headings for the different pricing arrangements applicable to each type of customer. For example the fashion house might have sales types for:\r\n<br /><br />\r\n<ul>\r\n<li>Indented sales - ordered in advance.\r\n<li>Stock sales - sold from stock.\r\n<li>Made to Measure - sales made up especially for a customer.\r\n</ul>\r\nInventory categories by contrast refer to the type of garment sold. Each customer is defined as belonging to a specific sales type. A sales type could also be used for groupings of customers. Price lists are held against sales types so all customers defined as belonging to the sales type will be on the same pricing.\r\n<br /><br />\r\nPricing can be set up for each stock item by sales type (and currency), e.g. stock sales would attract a premium for the cost of the increased working capital required or perhaps a discount reflecting the scale of purchasing allowed on volume lines. Sales types for retail, wholesale, trade, special may also be appropriate in other types of business.\r\n<br /><br />\r\nNew sales types/price lists can be added and existing ones amended from setup tab, "Sales Type Maintenance"\r\n<br /><br />\r\n<font size="+1"><b>Sales Type Code</b></font>\r\n<br /><br />\r\nThis is a 2 character code which is stored against the customer to define the sales type applicable to the customer. It must be unique across all sales types. When entering orders the customer sales type is the key, together with the customer\'s currency that determines the price list to use.\r\n<br /><br />\r\n<font size="+1"><b>Sales Type Description</b></font>\r\n<br /><br />\r\n20 characters of text are allowed to describe the sales type. This field is used to describe the sales type / price list applicable to the customer.\r\n<br /><br />\r\n<font size="+2"><b>Payment Terms</b></font>\r\n<br /><br />\r\nFor each customer the payment terms which the business deals with them under must be specified. This provides the information required to monitor whether the account is due or not - ie for Overdue inquiries and reports. Also, the invoices, credit notes and statements, contain reference to these terms so he/she is continually reminded of these terms with every transaction as a matter of course.\r\n<br /><br />\r\nPayment terms can take one of two forms:\r\n<br /><br />\r\n<ul>\r\n<li>Due after a specified number of days after invoice.\r\n<li>Due on a day in the month following invoice\r\n</ul>\r\nThe system allows the definition of a payment terms record either way. \r\n<br /><br />\r\nNote: The overdue report and inquiries use the estimated number of days to deliver in the branch record to determine when the customer received the goods, the payment terms are added to the day when delivery was effected.\r\n<br /><br />\r\n<font size="+1"><b>Payment Terms Code</b></font>\r\n<br /><br />\r\nThis is the code which is used by the system internally to reference the payment terms applicable to a customer. Alterations to this code will cascade through all the customers set up with the code being amended. If there are a lot of customers set up with this code it could take a moment to update all customers.\r\n<br /><br />\r\nIt is a 2 character text field.\r\n<br /><br />\r\n<font size="+1"><b>Payment Terms Description</b></font>\r\n<br /><br />\r\nThis field (40 characters of text) shows on customers statements, invoices and lookups in the inquiries and selection forms. It should describe as succinctly as possible the payment terms.\r\n<br /><br />\r\n<font size="+1"><b>Days Before Due / Day In Following Month When Due</b></font>\r\n<br /><br />\r\nOnly one of these fields needs to be entered depending on the selection in the bullet options. If the terms are after a number of days, then the field expects the number of days after which the invoice becomes due. Alternatively, the day in the following month when the invoice will fall due (greater than or equal to 0 and less than or equal to 30). These figures are used to calculate whether or not an invoice is overdue for the overdue reports and inquiries.\r\n<br /><br />\r\nThese fields expect a number - other characters are not accepted.', 'S');
INSERT INTO `Help` VALUES (26, 22, '<font size="+2"><b>Entering Customer Branches</b></font>\r\n<br /><br />\r\nA customer code entered on its own is insufficient to enter sales orders against. All customers must have at least one branch. The branch records contain the information about the delivery address, the sales area, the tax code, the sales representative and other regional information. New branches can be set up at any time. The first step will always be to select the customer, then to Add/Edit/Delete Customer Branch Records from the Customer menu. There is no limit to the number of branches that can be referenced against a single charge account (customer record). However, branches cannot be transferred between different customers. Only one statement will print per customer, but each invoice will be referenced to the branch it was delivered to.\r\n<br /><br />\r\n<font size="+1"><b>Branch Name</b></font>\r\n<br /><br /> \r\nThe branch name can be up to 40 characters long. The branch name is used on packing slips to identify the name to where delivery should be made. It is also used in lookups in sales order entry as it is to the branch that the sale is ordered against. By selecting the branch from this lookup, the customer code and branch code is returned to the system for storing against the order.\r\n<br /><br />\r\n<font size="+1"><b>Branch Code</b></font>\r\n<br /><br />\r\nThe branch code is stored in transactions. It can be up to 10 characters long and should uniquely identify the branch. Two branches cannot have the same code for the same customer. Branch codes (and other codes) cannot contain spaces, commas, & or - . There are checks in place to ensure no new codes are created containing these characters. However, if data is imported it is important to change any codes which contravene these rules.\r\n<br /><br />\r\nBranch codes are not available for modification retrospectively. They exist in many tables throughout the database - sales analysis, orders, DebtorTrans and CustTrans and all data in these tables would need to be modified.\r\n<br /><br />\r\n<font size="+1"><b>Branch Contact / Phone / Fax / Address</b></font>\r\n<br /><br />\r\nThe branch contact is the name of the purchasing manager to whom goods and inquiries would be addressed at the branch. A head office branch could be created to identify contact names for account inquiries. It doesn\'t matter that such a branch may not be invoiced to.\r\n<br /><br />\r\nThe address is the physical address of the branch for deliveries. As much detail as is required on labels to get the goods to the desired destination should be entered.\r\n<br /><br />\r\n<font size="+1"><b>Sales Person</b></font>\r\n<br /><br />\r\nA select box is available to enter the salesperson who services this branch. \r\n<br /><br />\r\n<font size="+1"><b>Draw Stock From</b></font>\r\n<br /><br />\r\nBranches local to a particular warehouse can be associated with the local warehouse by setting this field to the preferred stocking location. This affects the entry of sales orders that default to the stock location entered here. It can be overridden at the time of order entry.\r\n<br /><br />\r\n<font size="+1"><b>Forward Date From A Day In The Month</b></font>\r\n<br /><br />\r\nThis field is not currently used.\r\n<br /><br />\r\n<font size="+1"><b>Delivery Days</b></font>\r\n<br /><br />\r\nThis field is not currently used.\r\n<br /><br />\r\n<font size="+1"><b>Phone/Fax/Email</b></font>\r\n<br /><br />\r\nThese are the contact details applicable to the branch.\r\n<br /><br />\r\n<font size="+1"><b>Tax Authority</b></font>\r\n<br /><br />\r\nThe tax authority of the branch determines the regime for tax calculations at invoice and credit time. \r\n<br /><br />\r\nTax Authorities are the authority that collects the taxes. Different authorities in different countries mainly or different states in the USA. Say sales tax in New York is 10% and sales to customers in Michigan attract sales tax at a different rate payable to a different state tax authority. \r\n<br /><br />\r\nIn the UK, Australia and NZ, the Inland Revenue, Australian Tax Office and  the IRD are the relevant tax authorities. Sales to customers that fall under the ATO from a company in NZ do not attract any tax - ie exempt export. However, the same customer who has a branch in Auckland NZ will fall under a different tax authority the NZ IRD - attracting GST @ 12.5% for the same item delivered there. \r\n<br /><br />\r\nSo the tax authority is the factor relevant based on where the branch of the customer is who is receiving the supply.\r\n<br /><br />\r\nThe tax authorities are maintained in a separate table (available from the Setup tab) and the tax rate applicable to invoices and credits and the general ledger posting of tax is determined from the Tax Authority setting of the branch together with the applicable level of tax specified in the item (stock) master. \r\n<br /><br />\r\nA select box allows the appropriate tax authority for the branch to be selected.\r\n<br /><br />\r\n<font size="+1"><b>Disable Transactions</b></font>\r\n<br /><br />\r\nThis flag - either enabled or disabled - either includes the branch as available for new sales orders or not. If it is set to disabled then the branch will not appear on the order entry branch lookup.\r\n<br /><br />\r\n<font size="+1"><b>Default Freight Company</b></font>\r\n<br /><br />\r\nA select box allows the selection of the freight company that is most cost/service effective for deliveries to this branch. The entry in this field serves as the default for future sales orders. If it is changed at order entry stage, the overridden entry become the new entry for this field.\r\n<br /><br />\r\n<font size="+1"><b>Postal Address 1, 2, 3 and 4</b></font>\r\n<br /><br />\r\nThis is the postal address of the branch. There is no checking done to ensure this is entered. The only place this would be used is if the customer record required that invoices and credits be addressed to the branch.', 'S');
INSERT INTO `Help` VALUES (27, 96, '<font size="+2"><b>Shippers</b></font>\r\n<br /><br />\r\nThis table is only used as a reference to the method of transportation that the invoice delivery was effected by. The shippers name is what is used in the look ups and the code is a system maintained counter which is stored in the database to reference the freight company used. The consignment note reference can be stored against the transaction in the reference field. In this way a full proof of delivery trail can be maintained. \r\n<br /><br />\r\nShipment cost calculations can be automated and the result automatically added to invoices. The least cost shipper is calculated and modified on the order. This system requires active maintenance of the shipment costs tables for each shipper. The shipper costs table shows the cost per kg and metre cubed for freight to destination cities. A substantial amount of data is required. For the system to calculate freight, it also requires that each part have a defined volume and weight set up from which the total order weight and volume is determined for use in the freight calculations.\r\n<br /><br />\r\nIf freight cost calculations are to be performed at order entry stage, the data must be entered and the options in config.php enabled - see the config.php section.', 'S');
INSERT INTO `Help` VALUES (28, 16, '<font size="+2"><b>Credit Status Ratings</b></font>\r\n<br /><br />\r\nEach customer can be given a credit status that describes the risk as assessed by the credit controller, attached to invoices to the customer. This will never appear on any reports to customers. The customer selection screen allows customers to be restricted by their credit status so it is easy to perform inquiries on all the customers with a similar credit status. In addition the system will not allow invoices to customers whose credit status has a check in the field to prohibit invoicing. This is another credit control tool to the credit limit. \r\n<br /><br />\r\nCredit Status Ratings can be amended and created from the main menu set up tab from the link labelled Credit Status Maintenance.\r\n<br /><br />\r\n<font size="+1"><b>Status Code</b></font>\r\n<br /><br />\r\nThis is any number from 1 to 100. A rating code is required to be held against every customer to identify the credit status of each. The code cannot be changed retrospectively.\r\n<br /><br />\r\n<font size="+1"><b>Status Description</b></font>\r\n<br /><br />\r\nThis field is used in look ups both in the customers amendment/entry and also in the customer selection screen. This is a text field up to 30 characters long.\r\n<br /><br />\r\n<font size="+1"><b>Disallow Invoices</b></font>\r\n<br /><br />\r\nFor all credit ratings set up, this field indicates whether or not the rating is serious enough to prohibit future invoicing to customers set up with this credit rating.', 'S');
INSERT INTO `Help` VALUES (29, 131, '<font size="+2"><b>Tax Calculations</b></font>\r\n<br /><br />\r\n<font size="+1"><b>Overview</b></font>\r\n<br /><br />\r\nMany countries and states have varying methods for the calculation of ad-valorem taxes on sales. There is some flexibility in the configuration of how these automatic calculations are made and to which general ledger accounts the postings are made to. If all else fails tax rates can be entered by line of the invoice or credit as necessary. Different rates of tax can be applied to each line item individually depending on:\r\n<br /><br />\r\n<ol>\r\n<li>Where the branch is that is to invoiced.\r\n<li>What the item being invoiced is - e.g. In many states reduced rates of taxes apply to the more essential items for basic sustenance.\r\n<li>From where the item is dispatched i.e. the warehouse  from which the goods are picked. The tax legislation in most countries require that supplies made within the country attract tax - GST/VAT or whatever.\r\n</ol>\r\n<font size="+1"><b>Setting up Taxes</b></font>\r\n<br /><br />\r\n<ul>\r\n<li>All the tax authorities under which goods are to be sold must be defined in the tax authorities table under the set up tab. The tax authority record requires the specification of the general ledger account codes where purchase tax is to be posted and where sales taxes are to be posted to, as well as a description as to what the tax authority is called. eg. UK Inland Revenue VAT, ATO -GST(Australia), NZ IRD-GST (New Zealand). If there are several ways in which taxes can be defined within a single authority then it is appropriate to set up another authority. One example might be the Netherlands where as well as charging tax (at 3 different levels) it is possible to dispatch goods to a customer in the Netherlands - from a warehouse in the Netherlands without adding tax to the invoice where the customer has an exemption arrangement and has agreed to pay the VAT on its purchases  themselves directly to the Dutch revenue authority.\r\n<li>Each customer branch is defined as falling under a particular taxing authority. The tax authority is the state body responsible for the collection of taxes. Note that the tax authority is not held against a particular charge account - customer account. It is the branch where the goods are delivered to which is important in determining how the tax calculations work, so it is the branch that is defined as within a particular tax authority.\r\n<li>Each stocking location or warehouse is also defined as within a particular tax authority. This is specified from the locations maintenance form.\r\n<li>Each stock item is defined as being subject to tax at a particular "tax level". The tax level is set in the stock item maintenance screen. In setting the tax level for each item some thought is required as to the taxing of the item under different authorities. Most tax authorities have just two rates of tax applicable i.e. 0% and the normal tax rate eg. 10% for Australia, 12.5% New Zealand. However, in some authorities there may be several tiered rates - the Netherlands has three rates of tax. The levels set for the items must be set based on the requirements of the tax authority (which the business requires goods to be sold within) with the most tax levels. The tax level entered against each stock item is entered against the stock master record. It is simply a number from 0 to 9 and defaults to 1.\r\n<li>The applicable rates of tax then need to be defined. A rate is required for supplies from each Stock Location Tax Authority to each of the defined Tax Authorities and Tax Levels. It is this table of rates that allows the system to determine the rate applicable to each line item invoiced, based on the branch to which the item is to be supplied, the item itself and the location from where the goods are delivered.\r\n</ul>\r\n<b>Sales only within one Tax Authority Example - 2 Tax Levels:</b>\r\n<br /><br />\r\nIn most tax authorities there are just two rates of tax 0% and some other rate lets say 10%. Sales to export customers will not be taxable as they are exempt. If the business simply operates in the one country, then things are very simple. Items that are zero rated have the stock master record modified to give them a tax level of 2. All other taxable items have the default tax level of 1.  Two Tax Authorities are defined, the first the country in which it operates and the other called Export. Customer branch records must be set with the Tax Authority of the country or Export. The location record of each of the warehouses is defined as being the country tax authority. Now the rates applicable to export tax authority will all be 0 for tax level 1 and tax level 2. The rate of tax applicable to the country tax authority will be 10% for level 1 and 0% for level 2.\r\n<br /><br />\r\n<b>Sales only within one Tax Authority Example - 3 Tax Levels:</b>\r\n<br /><br />\r\nMaybe zero-rated for food and 5% on clothing and 10% on all other goods. The tax rate of all food items should be set to say 2 and the tax rate of all clothing items set to 3 - all other taxable items at the full rate set to a tax level of 1. The tax rates for the country tax authority for tax level 1 set to 10%, level 2 0% and level 3 5%.\r\n<br /><br />\r\n<b>Sales Within Two Tax Authorities Example - 3 Tax Levels:</b>\r\n<br /><br />\r\nThe business has a warehouse in another country - (Tax Authority A) or state with a different revenue collection authority and one authority has two levels and the other has 3 levels (Tax Authority B) as in the two examples above. Rates need to be defined for deliveries from each warehouse to customer branches in each tax authority. In most cases the rate of tax applicable to exports will be 0% - exempt. Tax Authority A will have entries applicable to deliveries within Tax Authority A for each of the 3 tax levels (even though only 2 are applicable - the rate for level 3 will be the same as 1) and also for deliveries to Tax Authority B. Tax Authority B will have rates set up for each level for deliveries within Tax Authority B and also for deliveries to Tax Authority A - the later rates will most likely be 0%.\r\n<br /><br />\r\nThe logic used in determining the rate to be used is as follows:\r\n<br /><br />\r\nThe TaxAuthority of the warehouse the goods are delivered from, the TaxLevel of the item and the Tax Authority of the branch of the customer being delivered to are determined. Using all three of these factors the rate is returned from the TaxAuthLevels table.\r\n<br /><br />\r\nGeneral ledger posting relating to the taxes calculated are made in accordance with the codes set up in the Tax Authority table.', 'S');
INSERT INTO `Help` VALUES (30, 72, '<font size="+2"><b>Pricing and Discounting</b></font>\r\n<br /><br />\r\n<font size="+1"><b>Overview</b></font>\r\n<br /><br />\r\nPrices are held by Sales Type and Currency. When setting up a customer account the sales type applicable to the customer is defined as is the currency applicable to invoices to the customer. There is no limit to the number of sales types that can be defined and therefore no limit to the number of different price lists that can be maintained. Further flexibility is available in that where necessary prices specific to a customer can also be defined, normally pricing will be specific to a customer but the system also has the capability of making prices specific to a particular branch of a customer. If a price is flagged as specific to a branch it will not be used for all other sales of the item to the customer, the default price of the item will be used. Further flexibility in discounting is available through the discount matrix (see below). If an item has an additional discount this can be entered at the time of order. The user also has the ability to change the price manually at the time of order. Sales analysis records allow reporting on sales types, so the analysis will report the volume of business done under each set of special pricing arrangements. \r\n<br /><br />\r\n<font size="+1"><b>Maintaining Prices</b></font>\r\n<br /><br />\r\nTo maintain pricing, first an item must be selected. This can be done from the link "Select an Item " on any page or from the inventory tab of the menu the link "Modify Or Delete An Inventory Item Or Item Pricing" allows for a part to be selected. Once selected the options available to work with the item are shown, there is a link to "Maintain Pricing". The pricing page displays, the sales type and the currency of all prices defined for the item. The existing prices can be deleted or modified from this screen and new prices can be entered. It is not possible to enter two prices for the same sales type and currency.\r\n<br /><br />\r\nTo enter prices for a specific customer and branch, the customer must first be selected. (See selecting customers). Going to the select an item page after having selected an item now shows an additional link to maintain the special pricing "Special Prices for customer - customer code". Clicking this link shows, the normal price for the sales type and currency of the customer selected and any special prices defined for this item/customer combination. If no special pricing is defined then the page shows only the normal price with a note that no special pricing is defined for this item and allows entry of the new special price. If a special price exists then it can be deleted or changed. A customer with many branches can have a special price for each branch or just a single branch having a special price beyond the special customer price. A special price applicable to only one branch will not apply to any of the other branches. Also, a special price set up for the customer account but with a blank branch field will apply to all branches unless there is a specific price set up for the branch.\r\n<br /><br />\r\nPrices can be amended at any time. However, changes to a price do not automatically cascade into sales orders for the item that are yet to be delivered, these would have to be changed manually as necessary.\r\n<br /><br />\r\nThere is a utility page that has some options for making bulk changes to pricing avoiding extensive re-keying exercises. Great care should be taken with this facility. System administrator permission is required to access this page accordingly.\r\n<br /><br />\r\nThe script is called: Z_PriceChanges.php and is accessed from the Utilities index Z_index.php\r\n<br /><br />\r\nThis script allows bulk increase/decreases by percentage for specific or a range of stock categories and for specific sales types. There is the opportunity to update the pricing:\r\n<br /><br />\r\n<ul>\r\n<li>For all prices for the sales type within the stock categories selected or\r\n<li>For only the default prices for the sales type within the stock categories selected or\r\n<li>For the selected customer special prices - provided the customer selected belongs to the sales type selected in the bulk change screen.\r\n</ul>\r\nEqually flexible options exist for printing price lists from the main menu under the orders tab under inquiries and reports.\r\n<br /><br />\r\n<font size="+1"><b>Discount Matrix</b></font>\r\n<br /><br />\r\nThe discount matrix allows discounts to be set for quantity breaks across a range of products. Eg a business selling pens may have red, blue, black etc but offer a discount for orders greater than 100 irrespective of colour - even though these are separate items.\r\n<br /><br />\r\nItems to have such discounting must be specified in the stock item details screen as belonging to the same Discount Category - this is a 2 character field in the stock master table. In the example above the item codes for blue, red and black pens should all be set to the same 2 character code.\r\n<br /><br />\r\nCustomers to whom the discount structure should apply are specified by the sales type (the price list) field. The entry in the Discount Matrix table should refer to the sales type and the 2 character DiscountCategory of parts, the quantity above which the discount is to apply and the rate of discount applicable. Several entries in the discount matrix can be made at increasing discounts and volumes, for the same Discount Category and Sales Type.\r\n<br /><br />\r\nWhen an order is entered the system automatically reads the Discount Category of the parts and accumulates the quantities of like Discount Category parts to see if the order lines qualify for the discount. If special discount has been entered exceeding the discount matrix calculated rate - the higher manual entry over-rides the calculation. However, discount manually entered which is below the discount matrix calculation will be uplifted to the discount matrix rate.\r\n<br /><br />\r\nTo set up the discount matrix there are two elements:\r\n<br /><br />\r\n<ol>\r\n<li>The discount categories - need to be defined. Individual stock items can be modified in the stock details form or a special facility is available under the set up tab of the main menu - under the inventory set up section. This screen allows stock codes to be entered and verified before changing to the selected discount category.\r\n<li>The discount matrix itself. This is modified from a link on the set up tab under accounts receivable set up. For each sales type/price list the quantity break and discount applicable must be entered.\r\n</ol>', 'S');
INSERT INTO `Help` VALUES (31, 92, '<font size="+2"><b>Invoicing An Order</b></font>\r\n<br /><br />\r\n<font size="+1"><b>Selecting an Order To Invoice</b></font>\r\n<br /><br />\r\nAll invoices require a sales order to be entered first. \r\n<br /><br />\r\nFrom the main menu select the orders tab. Select Outstanding Sales Orders Maintenance. This page shows all the orders outstanding. If the order number is known it can be entered on this screen to select the order to invoice. Hit search orders and the order should show below, together with links to modify the order, print the packing slip and to invoice. Click the link to invoice the order.\r\n<br /><br />\r\n<font size="+1"><b>Producing An Invoice From A Selected Order</b></font>\r\n<br /><br />\r\nHaving selected an order to invoice the order line comes up for confirming the quantities of the order that were dispatched. If the quantity dispatched differs from the order the difference is recorded in the table OrderDeliveryDifferencesLog - and a report is available to show the orders that were not able to be delivered with the first dispatch. There is also opportunity to enter the freight charge and if necessary enter the tax charge - which will normally be calculated automatically based on the tax authority of the customer branch being invoiced. The date of the invoice is defaulted based on the time of day and the settings in config.php. If the hour (in 24 hour format) is after the setting of $DispatchCutOffTime in config.php, then the following day is deemed to be the invoice date, alternatively the invoice date will default to today. Where not all lines on the order are being invoiced there are two choices with how to deal with the balance. \r\n<br /><br />\r\n<ul>\r\n<li>Put the balance on back order\r\n<li>Cancel the line on the order\r\n</ul>\r\nFinally there is also a field for entry of any text on the invoice. Hitting the process invoice button updates the order as instructed and produces all the entries including general ledger postings (if integration is enabled in the company preferences screen - see setup) to record the invoice. Until the process invoice button is hit, no entries have been saved to the database and it is safe to leave the page at any stage without having changed anything - the invoicing process can be cancelled at any time simply by following a link to another page. The processing that takes place once the Process Invoice button is hit includes:\r\n<br /><br />\r\n<ul>\r\n<li>Creation of the stock movements for each line item on the order - or for the assemblies components - from the location entered at the time of the order, at the price as per the order. \r\n<li>Creation of the DebtorTrans record that records the invoice against the customer\'s account.\r\n<li>Creation of the general ledger jorunals to record the sale and debtor etc.\r\n<li>Updating the order for amounts dispatched, and the invoice number.\r\n<li>Creating/updating the sales analysis records of the items being sold.\r\n<li>Updating the stock quantities for all lines of the invoice and the components of all assemblies included on the order.\r\n</ul>\r\nIf the order is not to be invoiced to the customer or branch specified in the order, or pricing is to be changed then the order must be changed. These elements cannot be altered at the time of invoice, they must be altered in the order before it is confirmed for invoicing. Once an invoice is created it cannot be deleted or modified. The order is also updated with the invoice number that it was dispatched on.', 'S');
INSERT INTO `Help` VALUES (32, 87, '<font size="+2"><b>Credit Notes</b></font>\r\n<br /><br />\r\nCredit notes can be created in one of two ways:\r\n<br /><br />\r\n<ul>\r\n<li>From a customer inquiry screen if the user has the necessary permissions ( $PageSecurity=3 - see Security Schema) a link shows to allow an entire invoice to be credited. Having clicked this link there is opportunity to de-select some items from being credited so that only the part of the invoice that needs to be credited can be, with only minimal keying. The same credit note creation page as used in manual creation of credit notes will appear but with all the items from the orignal invoice already entered into the credit note.\r\n<li>Using the link on the main menu under the receivables tab, select the link to create a credit note. \r\n</ul>\r\n<b>Important Note:</b>\r\n<br /><br />\r\nIt is important to use credit notes to correct incorrect invoices correctly. Crediting a small price against a part implies that the goods were returned and the customer only credited a fraction of their worth. This is not the correct way to credit an overcharge. By default credit notes return the stock to the location specified, so the stock records will be overstated by the goods returned to stock by the credit note. To correct a pricing error a credit note for the invoice line at the incorrect charge must be done and a new invoice at the correct charge must be made up. This ensures that sales analysis records are not corrupted for the quantities sold and that stock records are maintained correctly. A special pricing adjustment type of credit note is available that does not have any cost implications for the sales analysis and has no stock physical movement record associated with it.\r\n<br /><br />\r\nThe process for creating a credit note manually is:\r\n<br /><br />\r\n<ul>\r\n<li>Select the customer to be credited, there are the usual selection options (a box to enter an extract of the customer\'s name and a box to enter an extract of the customer\'s code) \r\n<li>Select the items to be credited and the prices to be used in crediting the customer - the same quick entry option is available as is used in order entry. - where the part code and quantity to be credited is entered directly. Pricing is automatically determined by reference to the customer\'s sales type, currency with regard to any special pricing for the customer (and branch) being credited. If the search for a part functions are used, then after each part is selected the quantity can be updated after the item is selected.\r\n<li>Having selected all the items it is possible to edit the items to be credited by clicking the button of the code of the item on the summary, then editing the price and quantity.\r\n<li>Amounts to be credited for freight can be entered directly (this would be entered directly from the original invoice if the credit an invoice option was used from the customer inquiry screen).\r\n<li>The tax amount to credit is calculated automatically by default based on the tax authority of the branch being credited and the total of the line items and freight to be credited. It is also possible to select the manual option. Once having selected manual, the user should hit update to allow free entry of any amount in the tax field.\r\n<li>By default it is assumed that the goods in the credit note are being returned to stock. The location to where the goods are being returned must be selected from the selection box.\r\n<li>If the goods are not being returned to stock, they are to be written off perhaps as samples or showroom display, damaged goods or whatever, the credit note type option should be changed to goods written off. After changing the credit note type and hitting the update button, a new select box will allow a general ledger code to be selected (assuming the general ledger interface to accounts receivable is active - it will not show if there is no integration). The appropriate general ledger code should be selected from this box. The location to return the stock to select box will disappear since it is no longer relevant. A third option is to credit a pricing adjustment - this type does not create any stock movements and the sales analysis updates only affect the value no cost of sales updates take place.\r\n<li>Any text describing the reasons for the credit note should be entered in the narrative box provided.\r\n<li>After completing all the inputs required, hit the Process Credit Note button to create the credit note. The created credit note number will be reported confirming that it has been processed.\r\n</ul>', 'S');
INSERT INTO `Help` VALUES (33, 24, '<font size="+2"><b>Entry Of Receipts</b></font>\r\n<br /><br />\r\nThis system tracks the invoices and credits which are outstanding (a so called open item system) in contrast to systems which use a balance brought forward from the previous month to add and subtract current month transactions. Experience has shown balance forward systems whilst intuitive, often result in queries for more information with the inevitable question from customers "what was this balance made up of ?" . The statements produced by this system show a full reconciliation of the amounts outstanding against invoices and credits that are yet to be settled totalling the amount of the customer\'s account. In order to provide the necessary information to track outstanding amounts, invoice by invoice, the detail of the make up of payments must be entered.\r\n<br /><br />\r\nPayments received from customers are therefore entered in a two-stage process:\r\n<br /><br />\r\n<ul>\r\n<li>The amount of the payment received is entered in foreign currency together with the exchange rate at which this has been banked into local currency. Any details pertinent to the receipt such as the date, method of payment and any details (which can be recalled from inquiries later) are entered at this stage.\r\n<li>The foreign currency received is allocated to the invoices (and debit journals) on the customer\'s account. Put another way, the invoices that the payment is meant to be settling are matched off against the payment.\r\n</ul>\r\nIf the details of the make up of a payment received are not available at the time of banking, the receipt can still be entered to stage 1. However, the allocation must be done before the statement is produced if the account is to make sense.\r\n<br /><br />\r\nNote: Differences on exchange are only calculated once the receipt is matched against the invoices it is paying.\r\n<br /><br />\r\nReceipts relating to general ledger transactions can also be entered in the same batch as customer receipts.\r\n<br /><br />\r\nThe process of entering receipts is initiated from the main menu under the receivables tab - another link is also available from the general ledger tab. \r\n<br /><br />\r\nFirstly, the receipt header information is required, the bank account - one of the previously defined bank accounts (see setup), the date the batch of receipts are banked, the currency and exchange rate of the banking and the type of receipt together with any narrative. The currency can be selected from the defined currencies (see setup). The receipt types can also be selected - they are defined in config.php. Once this information is entered it must be accepted before the receipts in the batch can be entered.\r\n<br /><br />\r\n<font size="+1"><b>Receipt - Customer</b></font>\r\n<br /><br /> \r\nBy default once the a customer has been selected the following information is displayed:\r\n<br /><br />\r\n<ul>\r\n<li>The payment terms applicable, so amounts overdue can be easily noted from the allocation screen without having to go back and do an inquiry.\r\n<li>The payment discount percentage applicable. The user can then use this rate if applicable to calculate the discount applicable, depending on how much of the payment relates to "on time" invoices.\r\n<li>The currency that the currency is paying in.\r\n</ul>\r\n<font size="+1"><b>Receipt - Date</b></font>\r\n<br /><br />\r\nThe date that the receipt was received and banked. If a receipt is being entered retrospectively - or several days bankings are being done together, the default date (i.e. the current date) should be over written with the date the receipt was originally received. This date is used on the statement and the customer may not be able to tie up the receipt if an incorrect date is entered.\r\n<br /><br />\r\nCustomer account inquiries are shown in date order so the account will not show correctly if the date entered is not the date the money was received. The date is also used in the general ledger transaction created.\r\n<br /><br />\r\n<font size="+1"><b>Receipts - Currency and Exchange Rate</b></font>\r\n<br /><br />\r\nSelection of the customer automatically tells the system which currency to expect the receipt in. The customer\'s account is maintained in the currency selected in the customer maintenance screen. \r\n<br /><br />\r\nThe correct rate at which the bank has converted the foreign currency to local currency must be input, the system shows the calculation of the local currency banked at the bottom of the screen. The receipt cannot (therefore) be entered until the amount in local currency is known. The exact rate to enter in this field will be the foreign currency figure divided by the local currency figure.\r\n<br /><br />\r\nEg banked 1212 local, in customer\'s currency this was 400. \r\n<br /><br />\r\nRate is 400/1212 = 0.330033\r\n<br /><br />\r\nThe local currency calculated by the system should confirm that the rate entered is correct. The general ledger integration - if enabled - will produce a bank deposit for the local currency amount shown at the bottom of the screen, and reduce (credit) the Debtors Control account by the same amount. The system defaults the exchange rate to that set up against the currency in the currencies table.\r\n<br /><br />\r\nWhen the receipt is matched to invoices, any differences between the local currency amounts banked against the local currency invoiced are recorded against the invoices and written off the general ledger Debtors Control Account and written into the profit and loss account - (specified in the company record of the customer concerned) if the general ledger integration is enabled from the module options screen.\r\n<br /><br />\r\n<font size="+1"><b>Receipts - Payment Method</b></font>\r\n<br /><br />\r\nThe payment method is stored against the receipt and shows on the customer\'s statement. A banking report can also be run off based on the payment method to summarise the day\'s bankings, to automate the task of collating the different vouchers and summarising for the bank.\r\n<br /><br />\r\n<font size="+1"><b>Receipts - Amount</b></font>\r\n<br /><br />\r\nThe amount of the receipt in foreign currency is entered here. This cannot be 0. Although, negative receipts are allowed (to reverse incorrect receipts). \r\n<br /><br />\r\nNote: Care should be taken when allocating negative receipts to ensure that only previous allocations are reversed, strange results could occur if allocations are made to invoices not previously allocated to positive receipts - although system integrity will be maintained.\r\n<br /><br />\r\n<font size="+1"><b>Receipts - Discount</b></font>\r\n<br /><br />\r\nThe amount of discount on a receipt can be entered at this point and allocated together with the receipt as one amount. This is useful, where a customer pays an amount net of discount - quite correctly according to his terms and conditions, and the amount naturally will not tie up to invoices on its own without the addition of the discount. The system calculates the gross amount of the payment including discount to set off the customer\'s account.\r\n<br /><br />\r\n<font size="+1"><b>Receipts - Allocating to Invoices</b></font>\r\n<br /><br />\r\nOnce all the details necessary have been entered for the receipt - the customer, the exchange rate and the amount in foreign currency, the receipt is ready to be allocated to the invoices which is to settle.\r\n<br /><br />\r\nThis concept can seem strange to businesses that have previously operated customer accounts where they are only interested in the current months\' transactions and the balance brought forward from last month. The aim of this system is to remove the question from the customer\'s lips ... "What is that figure, balance brought forward made up of?". Under the "Balance Forward" system this question can be a tough one to answer, since there is no record of which invoices were paid by which payment. However, this system needs explicit instructions for each receipt on which transactions should be settled as a result.\r\n<br /><br />\r\nFrom the menu under the Accounts Receivable tab - Click on the link to Allocate Receipts or Credits.\r\n<br /><br />\r\nThis page shows all outstanding receipts and credits that are yet to be allocated. Clicking on the links against these receipts and credits takes the user to the outstanding transactions on the customers account that are available for allocation. This screen shows all unallocated transactions but only invoices are available to allocate the receipt or credit note to.\r\n<br /><br />\r\nNote that allocations of a receipt are not allowed to another receipt. If necessary, negative receipts can be used to reverse allocation against invoices and debit journals (although this is undesirable). Once entered, receipts cannot be deleted - (obviously this would be undesirable from the standpoint of proper internal controls).\r\n<br /><br />\r\nIf the whole of the receipt is not matched off against (allocated to) invoices and debit journals the system will prompt to ensure that this is what was intended. Unlike many systems, allocations can always be completed or amended later.\r\n<br /><br />\r\n<font size="+1"><b>Differences on Exchange</b></font>\r\n<br /><br />\r\nThe process of allocating receipts to invoices gives the system the information necessary to calculate the difference on exchange since the receipt converted at the rate specified in the receipt screen will equate to a different amount to the local currency equivalent of the invoices it is matched to, unless both the receipt and the invoices it is allocated to are converted at the same rate. \r\n<br /><br />\r\nThe difference calculated at the time of allocation can be seen on the receipt screen once the allocations are done and the screen closed and is itemised against the invoices to which it is allocated against. Unlike many systems the difference on exchange can be fully itemised transaction by transaction. Inquiries on the detail of receipts show the difference on exchange that the receipt is responsible for. Further the inquiry on where the receipt was allocated to will show the analysis of where the difference on exchange for the receipt under review came from.\r\n<br /><br />\r\nAlterations to the allocations naturally alter the difference on exchange. The general ledger interface produces a journal for only the movement of the difference on exchange for a given receipt each time its allocations are altered.\r\n<br /><br />\r\n<font size="+1"><b>Receipts Processing</b></font>\r\n<br /><br />\r\nMany customer receipts can be entered at a time and mixed together with receipts for nominal items i.e. receipts from vending machine or sales of fixed assets reimbursement for private use of company assets etc. Once all receipts have been entered the processing can take place. The system only stores the data entered in a server side cookie called a session until such time as the Process button is clicked. \r\n<br /><br />\r\nThe processing will give the batch of receipts a number and insert new receipt transactions against customer accounts and update the customer\'s record with the amount of and the date of the last payment. In addition if the general ledger interface is enabled, the journals to put the receipt into the bank account specified and to decrease the Debtors control account - specified in the company record are created. General Ledger journals are also created for the discount - if any, with the corresponding entry to the Debtors Control account. All the necessary account codes must be set up in the company preferences page under the setup tab and the bank account set up page.\r\n<br /><br />\r\n<font size="+1"><b>Deposits Listing</b></font>\r\n<br /><br />\r\nAfter processing has completed a link to print the deposit listing for the batch of receipts just entered is shown. The batch number is also reported. The listing shows the information required by banks in processing a batch of cheques. This deposit listing can be reprinted at any time from a link under the accounts receivable tab - reports and inquiries.', 'S');
INSERT INTO `Help` VALUES (34, 21, '<font size="+2"><b>Allocate Credits To A Customer\'s Account</b></font>\r\n<br /><br />\r\nThis option allows any credit amount - be it a receipt or a credit notes to be allocated to debit amounts - invoices . Receipts or credits that have previously been allocated are available for alteration of their allocations if necessary. There are two ways to perform this function:\r\n<br /><br />\r\n<ul>\r\n<li>From the menu select the accounts receivable tab and click the link to "Allocate Credits To Customer\'s Account". \r\n<li>From the customer account inquiry - there is a link to allocate any customer receipt or credit where the user has appropriate privileges.\r\n</ul>\r\nUsing the first method, by default the screen opens with only the receipts, credit notes and credit journals which have an amount outstanding left to allocate. If there are many receipts which have amounts outstanding and are not fully allocated to invoices and debit journals then this is an indication that there are allocations which need to be done. For the customer\'s statements to make sense, the allocations must be done. \r\n<br /><br />\r\nDouble clicking the receipt to allocate will then open the form that allows the allocations to be made. This screen brings up all the invoices and journals that are outstanding on this customer\'s account. Invoices that have already been paid off will not show. However, existing allocations made from the selected receipt or credit will show. Clicking a receipt or credit note from the customer inquiry screen brings up this same page.\r\n<br /><br />\r\nIf a mistake was made with previous allocations these can be rectified by selecting the previous receipt which was wrongly allocated, all the invoices which the receipt was allocated to will show (together with other invoices which are yet to be allocated to). The amounts allocated against them can be amended at will.\r\n<br /><br />\r\nNote: This is a complex area behind the scenes, to handle the changes that may result to the difference on exchange. The system calculates the alteration to the exchange difference which results from allocating the receipt to different invoices (or not being allocated at all) and creates the necessary journal in the general ledger - if the integration option is used - to ensure the debtors control account stays in balance with the list of balances. \r\n<br /><br />\r\n<b>It is recommended that help be sought if alterations in the program are required in this area.</b>', 'S');
INSERT INTO `Help` VALUES (35, 23, '<font size="+2"><b>Customer Inquiries</b></font>\r\n<br /><br />\r\nComplete "drill down" inquiries are available to extract the full detail of transactions. The system maintains more data than many systems, preferring to minimise the use of consolidated or batch entries, in favour of the full detail of each transaction. The enquires can show the account history for a customer and from this inquiry it is possible to look at the details behind each transaction, from the detail of the transaction it is possible to look at the line items on the original invoice and which receipts paid the invoice. The original invoice or credit can be viewed directly from customer inquiries and the general ledger transactions that were created by the invoice, credit or receipt may also be inspected.\r\n<br /><br />\r\n<font size="+1"><b>Customer Account inquiries</b></font>\r\n<br /><br />\r\nFrom any page, click the "select customer" link. Having selected the customer all links applicable to the customer show. Among them the customer transactions inquiry.\r\n<br /><br />\r\nBy default the inquiry screen shows only those transactions after a date six months ago. The default period can be modified by simple editing of the script CustomerInquiry.php. If transactions further back are required only occasionally and not by default - the date after which all transactions will show can be altered at will. When the screen opens the customer\'s account is shown in the currency of the customer. The aged analysis based on the customer\'s terms is displayed. \r\n<br /><br />\r\nIf the transaction is an invoice or a credit note a magnifying glass icon shows on the same line as the transaction. A click on this magnifying glass then opens a new window showing the detail of the invoice or credit note.\r\n<br /><br />\r\nIf the integration to the general ledger from accounts receivable - see the option to "Create GL entries for accounts receivable transactions" from the Company Preferences page under setup - then another link with the letters GL will show. This link shows a new page with the detail of the general ledger postings created by this transaction.\r\n<br /><br />\r\nIf the transaction is a receipt or a credit note and the user has appropriate access privileges, a book icon shows. Clicking this icon takes the user to the page for allocating receipts and credits - if the receipt or credit is already allocated then the detail of how the receipt/credit was allocated is shown together with other invoices that could be used for allocating against. Invoices that have previously been allocated will not show.\r\n<br /><br />\r\nMore (or less) history can be shown by changing the "Show all transactions after:\r\n<br /><br />\r\n" date - then clicking the refresh button. The balance on the customer\'s account should balance to the sum of the amounts outstanding. The amount outstanding is used to represent:\r\n<br /><br />\r\n<ul>\r\n<li>For Invoices, the amount which has not yet been settled by receipts or credit notes\r\n<li>For Receipts, the amount which has yet to be allocated (or matched off) against invoices.\r\n</ul>\r\n<font size="+1"><b>Transaction Detail inquiries</b></font>\r\n<br /><br />\r\nThe detail of transactions can be inspected via one of two avenues:\r\n<br /><br />\r\n<ul>\r\n<li>From the Customer\'s Account inquiry - click on the magnifying glass or the GL link against the transaction required.\r\n<li>From the Transaction Enquires - from the Accounts Receivable tab, click on the magnifying glass to see the actual invoice or credit note.\r\n</ul> ', 'S');
INSERT INTO `Help` VALUES (36, 2, '<font size="+1"><b>Aged Customer Balance Listing</b></font>\r\n<br /><br />\r\nFrom the main menu select Customers, Reports, "Aged Customer Balances/Overdues Report".\r\n<br /><br />\r\nThis report calculates the balances of the customers\' accounts according to the parameters specified in config.php $PastDueDays1 and $PastDueDays2. The report is generated in the currency of the customer. The currency of the report must first be selected and the range of customers accounts to print.\r\n<br /><br />\r\nThe report can be printed at two levels:\r\n<br /><br />\r\n<ul>\r\n<li>The full detail of the all outstanding amounts on the account, transaction by transaction analysed into current, Due, $PastDueDays1 and PastDueDays2. The detailed report also shows the terms applicable to each customer.\r\n<li>A summary of the account balances split in the same aged groupings.\r\n</ul>\r\nThis report recalculates the balance on the customer\'s account from the outstanding transactions and analyses each outstanding transaction based on the date of invoice plus the expected time to deliver to the branch invoiced.\r\n<br /><br />\r\nThe Aged Customer Balances can also be restricted to show just the accounts where there is some balance overdue. The same detail and summary reports are available. The resultant reports create pdf files that can be either saved or printed.', 'S');
INSERT INTO `Help` VALUES (37, 76, '<font size="+1"><b>Customer Statements</b></font>\r\n<br /><br />\r\nThe customer statement shows the outstanding transactions on the account. There is an option in config.php that allows transactions that have been settled at some time within the last month to be shown in a settled transactions section of the statement. The parameter, $Show_Settled_LastMonth should be set equal to 1 for this. If it is set to 0, then any settled transactions will not be shown on the statements. This saves printing zero balance statements and there is argument both ways as to which is best.\r\n<br /><br />\r\nWhen transactions are created, the date of the transaction determines the period into which it is posted in the general ledger. The date of the transaction is also used in the aging calculations used on the statement. All transactions to the date of the statement are included. It is not possible to print a statement as at some prior date. It may be necessary to delay the start of invoicing for the new month until all receipts are entered and allocated and the statements printed before processing new invoices that should appear on the following month\'s statement.\r\n<br /><br />\r\nProcedure - All receipts must be allocated for the aged analysis to be calculated correctly. Then from the main menu Accounts Receivable tab select from the reports and inquiries section, "Print Statements". The link will allow selection of a range of customers. A single customer\'s statement can be printed by selecting the same starting an finishing customer code. Statements will be printed in sequence of the Customer code set up in the customer details screen. A pdf file is created this can be saved or printed.', 'S');
INSERT INTO `Help` VALUES (38, 25, '<font size="+1"><b>Customer Transaction Listing Options</b></font>\r\n<br /><br />\r\nThis is accessed from the main menu, accounts receivable tab under the link "Transaction Inquiries".\r\n<br /><br />\r\nThis inquiry allows transactions to be listed based on the selection of criteria on screen. The page allows listing of receipts, invoices or credit notes within any specified date range.\r\n<br /><br />\r\nThis listing is shown on the screen and can of course be printed from the browser if necessary.', 'S');
INSERT INTO `Help` VALUES (39, 81, '<font size="+1"><b>Sales Analysis</b></font>\r\n<br /><br />\r\nFrom the main menu under Accounts Receivable Reports and Inquiries options, "Sales Analysis Reports". A list of all previously defined sales reports shows with links to:\r\n<br /><br />\r\n<ul>\r\n<li>Modify the design of the report - the header\r\n<li>Modify the columns of the report\r\n<li>Run the report and create a PDF file\r\n<li>Run the report to create CSV - comma seperated values report that can be read by any spreadsheet application.\r\n</ul>\r\nAlso from the bottom of this page it is possible to make up new reports to show most combinations of sales data. A seperate table of sales data is maintained by the system to enable these reports to be run as quickly as possible. \r\n<br /><br />\r\nA sales analysis report is made up of:\r\n<br /><br />\r\n<ul>\r\n<li>the report header defintion and\r\n<li>the report column definitions\r\n</ul>\r\n<b>Sales Analysis Report Headers</b>\r\n<br /><br />\r\nThe first step in creating a report is to enter the report header information. This includes:\r\n<br /><br />\r\n<ul>\r\n<li>Report Heading - any combination of characters to describe the report.\r\n<li>Up to 4 levels of grouping and the criteria for each grouping.\r\n</ul>\r\nEach grouping consists of a selection of one of:\r\n<br /><br />\r\n<ul>\r\n<li>Sales Area \r\n<li>Product Code\r\n<li>Customer code - the actual charge account\r\n<li>Sales type (or price list)\r\n<li>Product type (or stock/inventory category)\r\n<li>Customer branch\r\n<li>Sales person\r\n</ul>\r\nThe report groups on each level in sequence eg. A report with Group By 1 set to Product Code and Group By 2 set to Sales Area, would show the product code, then the areas underneath the product code where the item has been sold. Most often the more logical sequence might be to show the sales area as Group By 1 and the Product Code under the Group By 2 so that the sales of the product codes for each area appear together.\r\n<br /><br />\r\nEach Group By section requires a range to be specified. All criteria specified must refer to the coding as specified in the setup section of the relevant Grouping. Eg Sales Areas criteria must be entered as the area code - not the area description. The criteria from should be less than the criteria to otherwise the report will have no output. \r\n<br /><br />\r\n<b>Sales Analysis Report Columns</b>\r\n<br /><br />\r\nHaving created a header for the report the columns can then be defined. Columns for existing reports can be modified at any time. >From the main Sales Analysis Reports page - (Accounts Revceivable tab - Sales Analysis Reports) - there is a link on each report to "Define Columns". >From this link the columns for the report selected are shown, together with a form to allow input of new columns. The following input is required for each column defined:\r\n<br /><br />\r\n<ul>\r\n<li>A column number between 1 and 10. This number determines where abouts across the page the column is printed -1 is the closest to the left of the page and 10 is the closest to the right of the page.\r\n<li>Two fields are available for line 1 and 2 of the column heading. Any text can be input to a maximum of 15 characters in each.\r\n<li>Whether the column is a calculation or not. The input required for calculated columns is different from normal data columns.\r\n<li>For normal data columns -a range of periods to show the data for is required. The period from and to must be specified as the period number. Since periods are maintained almost invisibly by the system, there is a link provided from this screen to show the periods defined. If a single month is required then the period from will be the same as the period to.\r\n<li>The data to show in the column can then be selected from: Quantity, Gross Value, Net Value (after discounts), Gross Profit, Cost and Discount.\r\n<li>Budgeted sales or actual sales.\r\n</ul>\r\nIf the column is defined as being a calculation the range of periods are not required, neither is the selection of the type of data to show and the budget or actual. Changing the Calculation field to yes then hitting the enter information button, show the fields required for a calculation:\r\n<br /><br />\r\n<ul>\r\n<li>Numerator field - this the column number of the first parameter to the calculation- the numerator field is always required in a calculation.\r\n<li>Denominator field - this is the column number of the second parameter to the calculation if the calculation is to performed on two columns. If the operator of the calculation is to divide - then this column total will be on the bottom of the division calculation. If the calculation is to be done using a constant then this field can be left blank.\r\n<li>Calculation operator can be one of:\r\n<ol>\r\n<li>Numerator column divided by Denominator column\r\n<li>Numerator column divided by the constant\r\n<li>Numerator column multiplied by the constant\r\n<li>Numerator column plus the denominator column\r\n<li>Numerator column minus the denominator column\r\n</ol>\r\n<li>Constant can be any number for use in the calculations\r\n<li>Format type allows the output of the calculation to be expressed as either a percentage or a number.\r\n</ul>\r\nHitting the Enter Information button adds the column to the report definition. It should then show in the list of defined columns and a blank form for entering a new column definition. If a column is no longer required the list of column definitions shown has a link that allows it to be deleted. \r\n<br /><br />\r\nThe column number itself is a link to modify the definition of the column. The definition shows in the input form for alternation as necessary.\r\n<br /><br />\r\nClicking the link to maintain report headers shows the list of defined reports for modification or running. To run the report simply click on the Make PDF Report link.\r\n<br /><br />\r\nThese sales analysis reports have to look at a lot of information (and the reports are generated dynamically) as a result, they can take a minute or so to run on large databases. However, the design of the data has been done very carefully to ensure that reports generate dramatically faster than many such analysis engines.\r\n<br /><br />\r\n<b>Automating Sales Reports</b>\r\n<br /><br />\r\nHaving created reports it is possible to email sales reports to defined recipients. A script called MailSalesReport.php is a template for doing this. There are no links to this script and no security level is set up for it. All that is required is to save this script to another file named anything with an extension of .php under the same directory as the other scripts. \r\n<br /><br />\r\nThis script will need to be edited with the email addresses of the people to receive the report and the reportID - the system generated report number to be run. The lines to edit are:\r\n<br /><br />\r\n/*The Sales report to send */\r\n<br />\r\n$ReportID = 4;\r\n<br /><br />\r\n/*The people to receive the emailed report */\r\n<br />\r\n$Recipients = array(\'"Root" <root@localhost>\',\'"some one else" <someoneelese@sowhere.com>\');\r\n<br /><br />\r\nThe lines surrounded by /* and */ are comments.\r\n<br /><br />\r\nOnce edited to the ReportID or choice and the Recipients all entered the file should be saved.\r\n<br /><br />\r\nTo schedule the report to run an entry in crontab under a linux installation that would send the report at 0:0 each week day (assuming wget is installed in /usr/bin/wget and that the web server is on the same machine and the new script is called DailySalesReport.php) would be:\r\n<br />\r\n# Scheduled email of a daily sales report\r\n<br /><br />\r\n0 0 * * 2-5 root /usr/bin/wget http://localhost/web-erp/DailySalesReport.php\r\n<br /><br />\r\nsince the page has no output - it would be pointless running it in a web browser although it would initiate another email to the defined recipients.\r\n<br /><br />\r\nA similar template script is available called MailSalesReport_csv.php that mails the comma separated values file for a ReportID to the Recipients defined in the script in just the same way as MailSalesReport.php script above.', 'S');
INSERT INTO `Help` VALUES (40, 77, '<font size="+1"><b>Printing Invoices Or Credit Notes</b></font>\r\n<br /><br />\r\nFrom the Main Menu select the Accounts Receivable tab, under Inquiries and Reports, "Print Invoices or Credit Notes".\r\n<br /><br />\r\nThis page shows the last invoice and credit note created and some brief instructions on how to use the page. By default the page assumes that invoices are required. However, if credit notes are required, they can be selected from the list field. \r\n<br /><br />\r\nIf only one transaction is required then the number of the transaction should be entered in the field "Start invoice/credit note number to print". If a range of transactions is required then both fields are necessary to be completed.\r\n<br /><br />\r\nThere is also an option to print EDI invoices/credit notes. By default these are not printed as they will normally be dispatched electronically to the customer. However, some businesses and tax authorities require hard copy invoices and credit notes to be produced in any event.\r\n<br /><br />\r\nTwo options are available - Print, produces a html page of the invoice (or credit note), the resulting page can then be printed using the browser print functionality. The print PDF produces a PDF invoice (or credit note).', 'S');
INSERT INTO `Help` VALUES (41, 90, '<font size="+2"><b>Entry of Sales Orders</b></font>\r\n<br /><br />\r\nFrom the main menu, Orders tab, click the Order Entry link.\r\n<font size="+1"><b>Selection of the Customer and Branch</b></font>\r\n<br /><br />\r\nInitially, the order entry page shows the options to allow selection of a customer and branch. The customer is the actual charge account to where the order should be billed and the branch contains all the information about delivery. The customer search facilities are similar to the select customer script, but the code actually looks up on the branch code of the customer, only branches are displayed with accompanying customer charge to information. Searching for a customer can be either by entering a letter or letters in the branch code or by entering some keywords (or section of) in the customer name. Searching in this way minimises the result set returned (possibly over a dial up connection) to ensure the response is as speedy as possible to the users browser. All branches matching the criteria entered and not flagged as disabled for transactions, are returned each one with a button on the customer code. Hitting the button for the desired customer/branch selects it as the customer and branch to deliver the order to. There is opportunity later to modify the delivery details if need be. The order now shows the quick entry screen headed up with the name of the customer and branch, together with the sales type of the customer.\r\n<br /><br />\r\n<font size="+1"><b>Selection of Order Line Items</b></font>\r\n<br /><br />\r\nThere are two ways to select the line items for the order. \r\n<br /><br />\r\n<ul>\r\n<li>By default a "quick entry" screen shows allowing the direct entry of the inventory code and the quantity required for the order. The number of lines shown on this quick entry table is defined by a variable in config.php - $QuickEntryLines which is user modifiable. After the user has entered any number of lines into this table, hitting the Quick Entry button processes the items entered into the order. The prices are retrieved based on the sales type, the currency, customer branch and the charge to customer of the order. If there were insufficient lines to enter all part codes for the order, the same process can be repeated with the quick entry table shown below the order summary after the first quick entry has been processed.\r\n<li>On the quick entry screen there is a button to search parts. This button enables the user to search for a part based on the stock category and/or any part of the item\'s description and/or any element of the item\'s code. Hitting the search button after making appropriate entries in the code or description fields shows the part codes and descriptions together with picture of the item - if one has been uploaded to the server for all parts. Part pictures must be in .jpg format with a file name identical to the part code but with the extension .jpg, and it must reside in the directory specified in config.php for part_pics. The item code is displayed as a button and the system automatically puts one of the item selected onto the order. Additional parts can be selected in the same way.\r\n</ul>\r\nHaving selected the parts for the order, it is possible to edit the quantities, price and discount applicable to each line of the order. To get the order values to re-calculate the "Recalulate" button must be clicked (this is the compromise of using server side scripting - PHP - to the exclusion of any client side - java - processing). Discounts will be calculated using the Discount Matrix functionality described under that section within the order based on the quantities that are entered. \r\n<br /><br />\r\nIf a line entered, displays against a red background this means that the system inventory is showing insufficient stock to cover the order line, from the inventory location as defaulted from the customer branch record - as the most appropriate inventory location to draw the stock for this branch\'s orders. The item code displayed is also a link to a new browser window showing the stock status inquiry for the item, this shows the stock available at all locations.\r\n<br /><br />\r\nA line can be deleted at any time by clicking on the link at the end of the line to delete it.\r\n<br /><br />\r\nThe whole order can be cancelled at any time by clicking on the "Cancel Whole Order" button.\r\n<br /><br />\r\nThe customer can also be changed at any time.\r\n<br /><br />\r\nOnce all the line items have been selected the Delivery Details button must be clicked. Note that there have been no changes to the database at all. The data entered exists only as a server side cookie - a file on the web-server. Delivery details must be confirmed before the order can be placed.\r\n<font size="+1"><b>Delivery Details</b></font>\r\n<br /><br />\r\nBy default the delivery details are obtained from the physical address of the branch. However, any of the information in this screen can be over-ridden. This information prints on the dispatch/packing slip and on the invoice. \r\n<br /><br />\r\nThe inventory location where the stock for the order is to be drawn from is defaulted from the customer branch record. However, it is possible to select an alternative inventory location if the order is to be picked from elsewhere.\r\n<br /><br />\r\nThe customer\'s order reference should be entered here and the most appropriate freight company should be selected. The system keeps track of the last freight company used to deliver to the branch and uses this as the default, if it is over-ridden then this new value is stored against the branch.\r\n<br /><br />\r\nIt is possible to go back to the line item entry screen retaining all the data entered on the delivery details screen by clicking on the modify line items button. If the inventory location to draw from has been changed the colouring of the background of the line items will be updated to reflect the stock available at the new location to pick from.\r\n<br /><br />\r\nIf the automatic freight calculations are being used - see the parameters in config.php, the freight cost will be calculated based on the sum of the whole order cubic metres and weight. The best shipping company will also be returned. The user can choose to charge the freight calculated or just use the cheapest freight company. The freight charge calculated can be over-ridden if required.\r\n<br /><br />\r\nOnce all details are entered correctly the Place Order button should be clicked. It is important to note that abandoning the order before this button is clicked there have been no updates to the database and nothing is saved. Clicking into some other screen loses the order as entered. Whilst it is perfectly acceptable to have several browser screens open looking at different inquiries at the same time. It is not possible to have two windows entering two separate sales orders at the same time, entries in the one window will over-write the other.', 'S');
INSERT INTO `Help` VALUES (42, 92, '<font size="+1"><b>Modfiying An Order</b></font>\r\n<br /><br />\r\nOnly Outstanding sales orders can be modified. Only these orders have any balance of a quantity remaining to be delivered and/or invoiced. Order lines that have been invoiced completely will not be available for modification. New items cannot be added to the order. Pricing cannot be altered if any amount of the line has already been delivered/invoiced. Quantities of an order line cannot be reduced below the quantity of the line already invoiced.\r\n<br /><br />\r\nNote that changing the delivery address of an outstanding order that has already had some of the order delivered and invoiced will affect re-prints of the initial invoice - it will show as being delivered to the order delivery address that has been modified. Hard copy of original invoices are required.\r\n<br /><br />\r\n<b>Selecting an Outstanding Sales Order</b>\r\n<br /><br /> \r\nThere are several ways:\r\n<br /><br />\r\n<ul>\r\n<li>If the item ordered is known, sales orders can be selected that have the item on by first selecting the item in the Select Item page, once the item is selected a link to show outstanding sales orders is displayed.\r\n<li>If the customer is known, then first select this customer then use the link on the customer selection menu to show only the outstanding orders for the customer selected.\r\n<li>All outstanding orders can be displayed by entering the Outstanding Sales Orders screen without a customer or item directly from the main menu under the orders tab. The outstanding Sales Orders screen also has facilities for looking up a part directly as well.\r\n</ul>\r\nThe Outstanding sales orders are shown by inventory location, the inventory location desired can be selected on this screen, by default the location defined as the default for the user is shown. The orders matching the criteria are only shown when the user clicks on the search orders button.\r\n<br /><br />\r\nThe orders displayed each show links to modify the line items, invoice the order or print the dispatch note. If the order has already been printed this link will show that it has already been printed to avoid printing several dispatch notes and risk doubling up deliveries.', 'S');
INSERT INTO `Help` VALUES (43, 95, '<font size="+2"><b>Shipments</b></font>\r\n<br /><br />\r\nThe shipment costing system is meant for use in situations where there are substantial freight costs on purchased products and the business wishes to keep track of the actual cost of these items. Many smaller businesses do these calculations on spreadsheets outside the integrated system. The advantage of bringing them inside the system is that the possibility for updating standards and calculation of variances from standard at the time the costing is completed.\r\n<br /><br />\r\nHaving selected a supplier the system allows outstanding purchase order items to be collated into a shipment of goods arriving altogether, the shipment is allocated a shipment number. By changing the expected time of arrival of the shipment (ETA) the delivery date of all purchase order lines on the shipment will be updated. The costs associated with landing and clearing this bundle of products can be entered against it from purchase invoice entry. Freight charges and cartage from the wharf, airfreight, unpacking, demurrage etc can be entered as costs of the shipment. The shipment costing inquiry will show these costs allocated against all of the items on the shipment, using the invoiced value of the items as the basis for apportionment. The actual shipment cost will show together with the existing standard cost and the variance.\r\n<br /><br />\r\n<font size="+1"><b>Shipment General Ledger Posting</b></font>\r\n<br /><br />\r\nShipment charges are posted to the GRN suspense account at the time of entry of the purchase invoice. When the shipment is closed the costs of the shipment are compared against the standard cost of the shipment items taken into stock and the difference that was left in the GRN suspense account is taken to purchase variances.\r\n<br /><br />\r\nIf the option to update standard costs at the time of closing the shipment is used, the difference on the stock value is taken to the stock category - stock adjustment, general ledger account.\r\n<br /><br />\r\n<font size="+1"><b>Creating Shipments</b></font>\r\n<br /><br />\r\nAfter selecting the supplier from which the product has been sourced and having entered the purchase order(s) to initiate the transaction, from the select supplier menu, choose the link "Set up a New Shipment". Each time this page is called the system increments a shipment reference and shows the shipment number that will be used. The shipment page that shows allows, the details of the shipment to be entered.\r\n<br /><br />\r\n<ul>\r\n<li>The name of the vessel on which the product has been loaded\r\n<li>The voyage reference - this could refer to the HAWB in the case of airfreight\r\n</ul>\r\nThe above are not required if deemed unnecessary, but serve as a useful reference for following and tracking where product is currently and monitoring ETA through the shipping company who will need these details.\r\n<br /><br />\r\nIn addition to the above details the Expected Time of Arrival (ETA) is required to be entered.\r\n<br /><br />\r\nIt is important to hit the "Update Shipment Details" button after this data is entered. As clicking one of the add links will lose this information just entered otherwise.\r\n<br /><br />\r\nWhen the shipment entry screen is first displayed there is facility to select the inventory location where the purchase order has been requested to arrive. By default the user\'s default inventory location will be used, but once the inputs above are entered the location can be changed and a click on the "Update" button will then show all the purchase order items defined to arrive at the new location.\r\n<br /><br />\r\nOnce a purchase order item has been selected to be part of the shipment the shipment entry screen will only allow other purchase order items that are also to be delivered to the same location. The location will be displayed on screen for informational purposes only.\r\n<br /><br />\r\nThe location into which the shipment is to be delivered follows the purchase order. It is not possible to set up a shipment with purchase order lines into different locations.\r\n<br /><br />\r\n(NB. it is possible to change the location of a purchase order that has lines on it that are allocated to a shipment that also has other lines expected to be delivered into a different location. This could result in a problem)\r\n<br /><br />\r\nThe purchase order line items on outstanding orders that are yet to be invoiced and are not currently on a shipment are shown on the screen. Clicking on the link to "Add" will add the line to the shipment. The lines currently allocated to the shipment will show and a link to "Delete" the line. This allows the line to be taken off the shipment (it will not delete the purchase order line).', 'S');
INSERT INTO `Help` VALUES (44, 97, '<font size="+1"><b>Shipment Costings</b></font>\r\n<br /><br />\r\nThe costs of a shipment are recorded at the time of purchase invoice entry. Entering a purchase order from the supplier of the shipment, records the actual amount invoiced and the exchange rate at which it was invoiced against the shipment. It is important to ensure the shipment is defined before any of the item is invoiced. Once some of the item is invoiced it is not available for adding to a shipment. Nor can the item be taken off a shipment to which it was already set up against. The item must be credited before this can be done. The recording of the shipment cost happens invisibly behind the scenes for GRN items.\r\n<br /><br />\r\nFreight charges, duty and cartage are recorded against the shipment at the time of the purchase invoice entry against the freight company. There is opportunity to enter invoices against a shipment and all open shipments show in a select box.\r\n<br /><br />\r\nSelecting a shipment is done from the select supplier screen. The shipments defined for the supplier are shown for the users\'s default inventory location. The location can be changed to show shipments into other locations. By default only open shipments are shown but there is an option to show closed shipments as well. The vessel, voyage and ETA show for all shipments shown together with links to allow:\r\n<br /><br />\r\n<ul>\r\n<li>Modification of the shipment lines or ETA or references.\r\n<li>Viewing the costing with invoiced amounts in local currency against each item together with the other general shipment charges - shown by supplier and invoice number.\r\n<li>Closing the shipment costing.\r\n</ul>', 'S');
INSERT INTO `Help` VALUES (45, 94, '<font size="+1"><b>Closing a Shipment</b></font>\r\n<br /><br />\r\nFrom the select Shipment screen, the link to close a shipment shows on all open shipments. Closing the shipment makes it impossible to post additional charges against it and also if general ledger stock integration is active, journals to take the variances from standard to the variance account and the GRN suspense are created. Closing a shipment also has an option to update the standard costs. By default this is set to yes. Again if stock GL integration is enabled (see company preferences) then the cost adjustment journals are posted in the same way as if the cost adjustment was processed separately.', 'S');
INSERT INTO `Help` VALUES (46, 1, '<font size="+2"><b>Account Groups</b></font>\r\n<br /><br />\r\nThe account group is the parent object of a general ledger account for someone who understands OO programming. Child accounts created inherit the properties of the account group - ie the account will be a profit and loss account if it belongs to an account group that is a balance sheet account, the child accounts will display in the trial balance (TB) together in the sequence determined by the account groups sequence in the trial balance (TB).\r\n<br /><br />\r\nUsing a numbering system inhibits the ability to manipulate the format of the trial balance ie you have to be able to change the account code to change where an account appears ie\r\n<br /><br />\r\n10100 motor expense Copenhagen\r\n<br /><br />\r\n10110 motor expenses The Hague\r\n<br /><br />\r\n10120 motor expense Amsterdam\r\n<br /><br />\r\nwould be great but then if we wish to restructure so that Copenhagen expenses are all shown together and The Hague is now all shown together etc we will have to change the numbering. In web-erp all that is required is to change the account group. In the first situation we could have an account group for motor expenses and all these account numbers would be set up as belonging to the account group. We can decide whereabouts the account group should appear in the trial balance by changing the sequence in trial balance field. All accounts in the account group will show together. If we decided to change the trial balance to show The Hague expenses together as a separate group of costs, we could create an account group for the The Hague selling costs - or whatever, and change the motor expenses the Hague account no 10110 to be a member of that account group.\r\n<br /><br />\r\nAccount groups require the sequence in the trial balance to be specified and also whether the accounts in that group will be profit and loss accounts or balance sheet accounts.\r\n<br /><br />\r\nA balance sheet account is one where only the balance at the end of the period concerned is of interest. A profit and loss is one where we are interested in the movement over the period. eg. Motor expenses we are not concerned with the balance at the end of the month so much as how much was spent over the period of the profit and loss. However, for a bank account we wish to know what we have now as a balance not the movements in the account. As noted accounts created as a member of an account group will inherit the properties of the account group ie if the account group is a balance sheet group then the accounts will be interpreted as balance sheet accounts.', 'S');
INSERT INTO `Help` VALUES (47, 8, '<font size="+2"><b>Bank Accounts</b></font>\r\n<br /><br />\r\nCertain general ledger accounts can be defined as bank accounts - as many bank accounts as needed can be defined. General ledger accounts defined as bank accounts can be reconciled to bank statements using the matching facilities. Entries made to bank accounts using receipts or payments, also create a total receipt or payment, which is retained for the purposes of matching off the bank statements. Using the bank payments page, general ledger payments can be analysed to any number of other general ledger accounts, but only one entry to the bank account is made. This page also allows payments to supplier accounts to be created. Similarly, using the receipt entry page, a series of receipts from customers which may all have been banked together can be deposited as one amount to a bank account. There is only one amount appearing on the statement as the total of all these receipts, this bank account transaction is created and available for matching deposits off the bank statements.\r\n<br /><br />\r\nOnce all receipts and payments are matched to bank statements, the bank reconciliation statement can be printed which should show how the current general ledger balance reconciles to the bank statement for this account.\r\n<br /><br />\r\nBank accounts are defined from the setup tab from the link to Bank Accounts Maintenance. There is facility to enter the name of the account, the bank account number and the address of the bank if required, as well as selecting the general ledger account to which it refers. There are links to edit existing bank account records and to delete them. However, once defined as referring to a particular general ledger code it is not possible to change the general ledger code of the bank account. This is because there would be entries made to this account. Similarly, if bank transactions have been created using this bank account it is not possible to delete it. The bank account transactions must be purged first (but currently no facility exists to purge bank transactions).', 'S');
INSERT INTO `Help` VALUES (48, 70, '<font size="+1"><b>Bank Account Payments</b></font>\r\n<br /><br />\r\nFrom the general ledger tab, the first link under transactions is Bank Account Payments.\r\n<br /><br />\r\nThe following data is required:\r\n<br /><br />\r\n<ul>\r\n<li>The bank account from which the payment has been (or is to be) made. A select box allows this to be selected from the list of defined bank accounts.\r\n<li>The date on which it was paid. This is important since the accounting period in which the payment is entered is determined from the date. The system will default to today\'s date - this must be changed where bank payments are being entered retrospectively.\r\n<li>The currency which is being paid. The entries to all bank accounts are made in local currency, but payment to suppliers may be made in foreign currency being purchased in local currency at the exchange rate entered. All bank accounts are recorded in local currency (there is no facility for foreign currency bank accounts). By default the system will use the functional currency of the business as defined in the company preferences page.\r\n<li>The exchange rate - if the functional currency of the business is being used this should be 1. If another currency is being purchased with the payment then the rate at which it is being purchased should be entered.\r\n<li>Narrative - applicable to the whole payment. Narrative applicable to individual general ledger entries can be entered separately.\r\n</ul>\r\nPayments can take two forms - either it is a general ledger payment or it is a payment to a supplier. General ledger payments require an analysis of how the payment should be posted to the general ledger. General ledger accounts can be specified either as the account code directly (if the account code is known) or by selecting from the select box. Any narrative applicable to the general ledger amount can be entered too - and the amount to be posted to the selected/entered account. The total payment is taken as being the sum of all the entries made. If the total of all entries made is negative then this is entered as a negative payment - these are accepted to allow for correction of data entry errors.', 'S');
INSERT INTO `Help` VALUES (49, 83, '<font size="+1"><b>Sales Journals</b></font>\r\n<br /><br />\r\nThe general ledger accounts that are used in this level of integration are determined from several inputs. \r\n<br /><br />\r\n<ul>\r\n<li>Sales Area of the customer being invoiced/credited\r\n<li>Sales Type (or price list) of the customer being invoiced/credited.\r\n<li>Stock Category of the item being invoiced/credited.\r\n</ul>\r\nA table of sales general ledger accounts is maintained and can be modified from the setup tab. When an invoice is created from the ConfirmDispatch_Invoice.php script the system uses a function defined in GetSalesTransGLCode.inc to look up the general ledger codes that are appropriate. By default this function uses the following logic:\r\n<br /><br />\r\n<ul>\r\n<li>If there is a record in the SalesGLPostings table that has a matching Area, SalesType and Stock Category then the function returns the sales account and the discount account applicable.\r\n<li>If there is a match for the Area and SalesType using the default Stock Category (ANY) then the codes applicable to this record are returned.\r\n<li>Then if there is a matching Sales type, stock category with default (AN) area this is used.\r\n<li>Then if there is a matching stock category record using the default area (AN) and the default salestype (AN) this is used - finally\r\n<li>If there is no record is found after trying the above combinations then the GL Code for the default area, sales type and default stock category is used - this is GL code 1. If GL Code 1 is not defined, then it will be created.\r\n</ul>\r\nSince the logic of how the general ledger account is determined is defined in this function it is relatively simple to change this to what is most appropriate for the business.\r\n<br /><br />\r\nThe freight recovery and the debtors control account used are those defined in the company preferences page.\r\n<br /><br />\r\nThe tax account used is the account defined in the tax authorities definition used for the customer being invoiced.', 'S');
INSERT INTO `Help` VALUES (50, 11, '<font size="+1"><b>Stock Journals</b></font>\r\n<br /><br />\r\nThe general ledger accounts that are used for posting sales transactions are determined using the sales area, the sales type of the customer being invoiced/credited and the stock category of the item being invoiced/credited. A table of general ledger accounts is maintained and can be modified from the set up tab from the link "COGS GL Interface Postings". The same logic as above is applied and the function is defined in the same GetSalesTransGLCode.inc script to look up the appropriate GL codes. Again, since the logic of how the general ledger account is determined is defined in the function GetCOGSGLAccount, it is relatively simple to change this to suit the business.\r\n<br /><br />\r\nThe account to credit stock with for the cost of goods sold is determined by reference to the stock item being sold. The stock category of the item is retrieved and the general ledger codes applicable to the stock category are used.\r\n<br /><br />\r\nThe profit and loss accounts used for stock adjustments are also determined by reference to the stock category record.\r\n<br /><br />\r\nThe profit and loss account used for posting the variance between standard cost of a purchased item and its actual cost as invoiced is also determined from the stock category record.', 'S');
INSERT INTO `Help` VALUES (51, 19, '<font size="+1"><b>EDI Setup</b></font>\r\n<br /><br />\r\nTo enable EDI transactions for a customer, first select the customer from the Select Customer link on any page, then click the link - Customer EDI Configuration. This page allows selection of the type of transactions that are to transmitted electronically currently only invoices/credit notes and orders are available. Each must be specifically enabled to activate them. Each customer must have their:\r\n<br /><br />\r\n<ul>\r\n<li>EDI reference that they are identified by\r\n<li>Transport mechanism and address to which the invoice/credit note messages are to be sent - either email as a file attachment or via ftp (file transfer protocol)\r\n</ul>\r\nIf the transport mechanism is to be ftp - this must be compiled into PHP with the flag -enable-ftp, most windows PHP installtions have this by default now. Additional fields for the ftp server username and password will also be required.\r\n<br /><br />\r\nTo activate EDI polling for invoices to send the script EDISendInvoices.php must be run as a scheduled job - using cron or some other scheduling system -see automating sales reports. It can also be run from the utilites menu Z_index.php with debugging output.\r\n<br /><br />\r\nTo activate EDI polling for orders to be entered as received the script ???? must be run as a scheduled job using cron or some other scheduling system.\r\n<br /><br />\r\n<font size="+1"><b>Sending EDI Invoices</b></font>\r\n<br /><br />\r\nEDI messages are made up of segments which must appear in a certain order. Since customers will require EDI invoices in slightly different formats, the exact format can be defined in the table EDIMessageFormat. This table has a record for each customer invoice line and the sequence when it must appear in the message. The field line text in this table can include any of the predefined EDI invoice variables surrounded by "[" and "]" to denote them as a variable to be replaced with the appropriate value as follows:\r\n<br /><br />\r\n<table>\r\n<th colspan="2">EDI Invoice Detail Section</th>\r\n<tr>\r\n<td>\r\nEDITransNo\r\n</td>\r\n<td>\r\nThe unique EDI transaction number\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nInvOrCrd\r\n</td>\r\n<td>\r\nWhether the transaction is an invoice or a credit - the value of this variable is an EANCOM defined number, 388 for a tax invoice and 381 for a credit note\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nTransNo\r\n</td>\r\n<td>\r\nThe transaction number of invoice or credit \r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nOrigOrDup\r\n</td>\r\n<td>\r\nWhether the transaction is a duplicate or original sending the value of this variable is an EANCOM defined number 7 for a duplicate and 9 for an original\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nTranDate\r\n</td>\r\n<td>\r\nThe transaction date in the format CCYYMMDD\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nOrderNo\r\n</td>\r\n<td>\r\nThe original order number - only for invoices\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustBranchCode\r\n</td>\r\n<td>\r\nThe customer\'s internal code for the branch\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCompanyEDIReference\r\n</td>\r\n<td>\r\nThe customer\'s EDI reference code\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBranchName\r\n</td>\r\n<td>\r\nThe branch name\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBranchStreet\r\n</td>\r\n<td>\r\n&nbsp;\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBranchCity\r\n</td>\r\n<td>\r\n&nbsp;\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nBranchState\r\n</td>\r\n<td>\r\n&nbsp;\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nTaxAuthorityRef\r\n</td>\r\n<td>\r\nThe businesses Tax Authority reference number\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nDatePaymentDue\r\n</td>\r\n<td>\r\nThe due date for this transaction\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nTaxTotal\r\n</td>\r\n<td>\r\nThe total amount of tax on the transaction\r\n</td>\r\n</tr>\r\n</table>\r\n<table>\r\n<th>EDI Invoice Detail Section - for the lines on the transaction</th>\r\n<tr>\r\n<td>\r\nLineNumber\r\n</td>\r\n<td>\r\n&nbsp;\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nStockID\r\n</td>\r\n<td>\r\nThe webERP item code \r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nCustStockID\r\n</td>\r\n<td>\r\nThe customer\'s internal code for the item\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nItemDescription\r\n</td>\r\n<td>\r\n&nbsp;\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nQtyInvoiced\r\n</td>\r\n<td>\r\nQuantity invoiced or credited\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nLineTotalExclTax\r\n</td>\r\n<td>\r\nThe total for the line excluding tax\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nUnitPrice\r\n</td>\r\n<td>\r\nUnit price for the item\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nLineTaxAmount\r\n</td>\r\n<td>\r\nThe tax applicable to the line\r\n</td>\r\n</tr>\r\n</table>\r\n<table>\r\n<th>EDI Invoice Summary Section</th>\r\n<tr>\r\n<td>\r\nNoLines\r\n</td>\r\n<td>\r\nThe total number of lines on the invoice/credit\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nTotalAmountExclTax\r\n</td>\r\n<td>\r\nTotal amount of the transaction excluding tax\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nTotalAmountInclTax\r\n</td>\r\n<td>\r\nTotal amount of the transaction including tax\r\n</td>\r\n</tr>\r\n<tr>\r\n<td>\r\nNoSegments\r\n</td>\r\n<td>\r\nThe total number of segments in the transaction this is required as a control check in the summary\r\n</td>\r\n</tr>\r\n</table>\r\nThere is therefore great flexibility in how the messages are defined. The variables for the summary and heading sections can be used in any section. The detail section variables can only be used in the detail section.\r\n<br /><br />\r\nMost customers will require that the branch to which the invoiced goods are delivered to, be identified using the customer\'s coding system. It is therefore important to ensure that the customer\'s branch code is actually entered against the webERP branch record. The variable CustBranchCode is retrieved from the branch record and if it is not entered then the EDI transaction will fail.\r\n<br /><br />\r\nSome customers may also require the item code to be their item code, not the webERP item code. The variable CustStockID is derived from the cross reference table EDIItemMapping which would need to contain a cross reference record for each item that they may buy.\r\n<br /><br />\r\nThe script that creates the EDI invoices (EDISendInvoices.php) should be run automatically in the background as a scheduled task. It first gets a list of all customers who should receive EDI invoices (or credit notes) - as determined in the settings of their DebtorsMaster record. Then the script goes through each customer returned in turn to get any invoices or credits that have not already been sent. A flat file is created for all the customers invoices and credits and sent to the customer using the transport, address and other parameters defined in the customer edi setup page - recorded against their DebtorsMaster record. There is a link to enable the script to be run manually - the browser will also show the output of the EDI message.', 'S');

ALTER TABLE `StockMoves` ADD `Narrative` TEXT NOT NULL;
ALTER TABLE `SalesOrderDetails` ADD `Narrative` TEXT NOT NULL ;
ALTER TABLE `DebtorTrans` ADD `Consignment` VARCHAR( 30 ) NOT NULL;
ALTER TABLE WWW_Users ADD Language CHAR(2) DEFAULT 'en' NOT NULL;
ALTER TABLE WWW_Users ADD Theme VARCHAR(30) DEFAULT 'professional' NOT NULL;
ALTER TABLE WWW_Users ADD DisplayRecordsMax TINYINT DEFAULT 0 NOT NULL;
UPDATE WWW_Users SET Theme='professional', Language='en';

INSERT INTO `Scripts` ( `PageID` , `FileName` , `PageDescription` )
VALUES ('162', 'UserSettings.php', 'Allows the user to change system wide defaults for the theme - appearance, the number of records to show in searches and the language to display messages in');

INSERT INTO `Scripts` ( `PageID` , `FileName` , `PageDescription` )
VALUES ('163', 'StockQuantityByDate.php', 'Shows the stock on hand for each item at a selected location and stock category as at a specified date');

ALTER TABLE `TaxAuthorities` CHANGE `TaxID` `TaxID` TINYINT( 4 ) NOT NULL AUTO_INCREMENT;

INSERT INTO `Scripts` (`PageID`, `FileName`, `PageDescription`) VALUES ('164', 'PDFOrderStatus.php', 'Reports on sales order status by date range, by stock location and stock category - producing a pdf showing each line items and any quantites delivered');

INSERT INTO `Scripts` ( `PageID` , `FileName` , `PageDescription` )
VALUES ('165', 'Tax.php', 'Creates a report of the ad-valoerm tax - GST/VAT - for the period selected from accounts payable and accounts receivable data');

INSERT INTO `Scripts` (`PageID`, `FileName`, `PageDescription`) VALUES ('166', 'PDFCustomerList.php', 'Creates a report of the customer and branch information held. This report has options to print only customer branches in a specified sales area and sales person. Additional option allows to list only those customers with activity either under or over a specified amount, since a specified date.');

COMMIT;